--Ultimate Randomizer Commands
--Made by Nightwolf

local urmain = assert(_URANDOM,"URANDOM: variables.lua isn't loaded properly!")

local commands = {}

--This queue is not synchronized (local)
local localCmdQueue = {}

addHook("NetVars",function(net)
	urmain.var.main.seed = net($)
	urmain.var.charrandom.isenabled = net($)
	urmain.var.charrandom.crtime = net($)
	urmain.var.charrandom.ultimate = net($) 
	urmain.var.charrandom.sa2random = net($) 
	urmain.var.charrandom.timeoffset = net($) 
	urmain.var.charrandom.shownextskin = net($) 
	urmain.var.charrandom.showtimer = net($) 
	urmain.var.objrandom.isenabled = net($)
	urmain.var.objrandom.setposition = net($) 
	urmain.var.objrandom.randomtype = net($) 
	urmain.var.objrandom.randomsize = net($)
	urmain.var.objrandom.randomrings = net($)
	urmain.var.maprandom.isenabled = net($)
	urmain.var.maprandom.maps = net($)
	urmain.var.maprandom.bossmaps = net($) 
	urmain.var.maprandom.specialstages = net($) 
	urmain.var.maprandom.autorandom = net($) 
	urmain.var.maprandom.mapnum = net($) 
	urmain.var.physrandom.isenabled = net($)
	urmain.var.physrandom.phtime = net($) 
	urmain.var.physrandom.speed = net($) 
	urmain.var.physrandom.spindash = net($) 
	urmain.var.physrandom.friction = net($) 
	urmain.var.physrandom.jumping = net($) 
	urmain.var.physrandom.actionspd = net($) 
	urmain.var.physrandom.showtimer = net($) 
	urmain.var.miscrandom.texturerand = net($) 
	urmain.var.miscrandom.flatrand = net($) 
	urmain.var.miscrandom.brightrand = net($) 
	urmain.var.miscrandom.colorrand = net($) 
	urmain.var.miscrandom.abilityrand = net($) 
	urmain.var.miscrandom.skyrand = net($)
end)

local function playeradmin(p)
	return (p == server or IsPlayerAdmin(p) or not netgame)
end

local function generalyn(yn,val,p)
	yn = tostring(yn)
	if yn == "yes" or yn == "1" then
		return true
	elseif yn == "no" or yn == "0" then
		return false
	else
		CONS_Printf(p,"Current value: "..tostring(val))
		return nil
	end
end

local function addToCmdQueue(cmd)
	if type(cmd) == "string" then
		table.insert(localCmdQueue,cmd)
	end
end

local function execFromCmdQueue(p)
	if #localCmdQueue > 0 then
		COM_BufInsertText(p,table.remove(localCmdQueue,1))
	end
end

local function clearCmdQueue()
	localCmdQueue = {}
end



commands.cr_enable = {
	adminonly = true,
	run = function(p,ena)
		local aa = generalyn(ena,urmain.var.charrandom.isenabled,p)
		if aa then urmain.var.charrandom.isenabled = 1; urmain.cr_putskinsifnone()
		elseif aa == false then urmain.var.charrandom.isenabled = 0
		else CONS_Printf(p,"ur cr_enable <0/1> - enable or disable Character Randomizer") end
	end,
}

commands.cr_time = {
	adminonly = true,
	run = function(p,time)
		time = tonumber(time)
		if not time then 
			CONS_Printf(p,"Current value: "..tostring(urmain.var.charrandom.crtime))
			CONS_Printf(p,"ur cr_time <0-3600> - set time between skin changes (CR)")
			return 
		end
		if time < 1 then time = 1 elseif time > 3600 then time = 3600 end
		urmain.var.charrandom.crtime = time
	end,
}

commands.cr_skin = { //This command is too big and complicated to be here
	adminonly = true,
	run = function(p,cmd,arg)
		COM_BufInsertText(p,"cr_skin "..tostring(cmd).." "..tostring(arg))
	end,
}

commands.cr_ultimate = {
	adminonly = true,
	run = function(p,ena)
		local aa = generalyn(ena,urmain.var.charrandom.ultimate,p)
		if aa then urmain.var.charrandom.ultimate = 1
		elseif aa == false then urmain.var.charrandom.ultimate = 0
		else CONS_Printf(p,"ur cr_ultimate <0/1> - enable or disable Character Randomizer's Ultimate mode") end
	end,
}

commands.cr_sa2random = {
	adminonly = true,
	run = function(p,ena)
		local aa = generalyn(ena,urmain.var.charrandom.sa2random,p)
		if aa then urmain.var.charrandom.sa2random = 1
		elseif aa == false then urmain.var.charrandom.sa2random = 0
		else CONS_Printf(p,"ur cr_sa2random <0/1> - enable or disable Character Randomizer's SA2 Rando mode") end
	end,
}

commands.cr_timeoffset = {
	adminonly = true,
	run = function(p,time)
		time = tonumber(time)
		if time == nil then 
			CONS_Printf(p,"Current value: "..tostring(urmain.var.charrandom.timeoffset))
			CONS_Printf(p,"ur cr_timeoffset <0-900> - set the maximum 'cr_time' offset (CR)") 
			return
		end
		if time < 0 then time = 1 elseif time > 900 then time = 900 end
		urmain.var.charrandom.timeoffset = time
	end,
}

commands.cr_shownextskin = {
	adminonly = true,
	run = function(p,yn)
		local aa = generalyn(yn,urmain.var.charrandom.shownextskin,p)
		if aa then urmain.var.charrandom.shownextskin = 1
		elseif aa == false then urmain.var.charrandom.shownextskin = 0
		else CONS_Printf(p,"ur cr_shownextskin <0/1> - show next skin in Character Randomizer or not") end
	end,
}

commands.cr_showtimer = {
	adminonly = true,
	run = function(p,yn)
		local aa = generalyn(yn,urmain.var.charrandom.showtimer,p)
		if aa then urmain.var.charrandom.showtimer = 1
		elseif aa == false then urmain.var.charrandom.showtimer = 0
		else CONS_Printf(p,"ur cr_showtimer <0/1> - show timer in Character Randomizer or not") end
	end,
}

commands.or_enable = {
	adminonly = true,
	run = function(p,str)
		local aa = generalyn(str,urmain.var.objrandom.isenabled,p)
		if aa then urmain.var.objrandom.isenabled = 1
		elseif aa == false then urmain.var.objrandom.isenabled = 0
		else CONS_Printf(p,"ur or_enable <0/1> - enable or disable Object Randomizer") end
	end,
}

commands.or_setposition = {
	adminonly = true,
	run = function(p,str)
		if str == "0" or str == "none" then
			urmain.var.objrandom.setposition = 0
		elseif str == "1" or str == "swap" then
			urmain.var.objrandom.setposition = 1
		elseif str == "2" or str == "random" then
			urmain.var.objrandom.setposition = 2
		else
			CONS_Printf(p,"ur or_setposition <0-none/1-swap/2-random> - change the way object position is set (excluding players)")
		end
	end,
}

commands.or_randomtype = {
	adminonly = true,
	run = function(p,str)
		if str == "0" or str == "disabled" then
			urmain.var.objrandom.randomtype = 0
		elseif str == "1" or str == "limited" then
			urmain.var.objrandom.randomtype = 1
		elseif str == "2" or str == "uniform" then
			urmain.var.objrandom.randomtype = 2
		elseif str == "3" or str == "smart" then
			urmain.var.objrandom.randomtype = 3
		elseif str == "4" or str == "full" then
			urmain.var.objrandom.randomtype = 4
		else
			CONS_Printf(p,"ur or_randomtype <0-disabled/1-limited/2-uniform/3-smart/4-full> - set the object type randomization mode (excluding players)")
		end
	end
}

commands.or_randomsize = {
	adminonly = true,
	run = function(p,str)
		if str == "0" or str == "normal" then
			urmain.var.objrandom.randomsize = 0
		elseif str == "1" or str == "limited" then
			urmain.var.objrandom.randomsize = 1
		elseif str == "2" or str == "great" then
			urmain.var.objrandom.randomsize = 2
		else
			CONS_Printf(p,"ur or_randomsize <0-normal/1-limited/2-great> - set the object size randomization mode (excluding players)")
		end
	end
}

commands.or_randomrings = {
	adminonly = true,
	run = function(p,str)
		local aa = generalyn(str,urmain.var.objrandom.randomrings,p)
		if aa then urmain.var.objrandom.randomrings = 1
		elseif aa == false then urmain.var.objrandom.randomrings = 0
		else CONS_Printf(p,"ur or_randomrings <0/1> - include or exclude rings & blue spheres from object randomization") end
	end
}

commands.mr_randomize = {
	adminonly = true,
	run = function(p)
		urmain.resetmrrng()
		local vars = urmain.var.maprandom
		vars.maps = {}
		vars.mapnum = 1
		local TOLFlag
		if multiplayer then TOLFlag = TOL_COOP else TOLFlag = TOL_SP end
		for i = 1,#mapheaderinfo do
			if not mapheaderinfo[i] then continue end
			if i == tutorialmap then continue end //Skip tutorial level
			if mapheaderinfo[i].typeoflevel & TOLFlag then
				if mapheaderinfo[i].unlockrequired > -1 then continue end
				if vars.bossmaps == 0 and (mapheaderinfo[i].bonustype > 0 or G_BuildMapTitle(i) == "Black Core Zone 1") then continue end
				if vars.specialstages == 0 and G_IsSpecialStage(i) then continue end
				table.insert(vars.maps,i)
			end
		end
		vars.maps = urmain.maprandshuffle(vars.maps)
		if p then CONS_Printf(p,"Maps randomized!") end
	end,
}

commands.mr_enable = {
	adminonly = true,
	run = function(p,str)
		local aa = generalyn(str,urmain.var.maprandom.isenabled,p)
		if aa then
			urmain.var.maprandom.isenabled = 1
			if #urmain.var.maprandom.maps == 0 then commands.mr_randomize.run() end
		elseif aa == false then 
			urmain.var.maprandom.isenabled = 0
		else
			CONS_Printf(p,"ur mr_enable <0/1> - enable or disable Map Randomizer") 
		end
	end,
}

commands.mr_bossmaps = {
	adminonly = true,
	run = function(p,str)
		local aa = generalyn(str,urmain.var.maprandom.bossmaps,p)
		if aa then urmain.var.maprandom.bossmaps = 1
		elseif aa == false then urmain.var.maprandom.bossmaps = 0
		else CONS_Printf(p,"ur mr_bossmaps <0/1> - enable or disable boss maps") end
	end,
}

commands.mr_specialstages = {
	adminonly = true,
	run = function(p,str)
		local aa = generalyn(str,urmain.var.maprandom.specialstages,p)
		if aa then urmain.var.maprandom.specialstages = 1
		elseif aa == false then urmain.var.maprandom.specialstages = 0
		else CONS_Printf(p,"ur mr_specialstages <0/1> - enable or disable special stages") end
	end,
}

commands.mr_autorandomize = {
	adminonly = true,
	run = function(p,str)
		local aa = generalyn(str,urmain.var.maprandom.autorandom,p)
		if aa then urmain.var.maprandom.autorandom = 1
		elseif aa == false then urmain.var.maprandom.autorandom = 0
		else CONS_Printf(p,"ur mr_autorandomize <0/1> - enable or disable automatic map randomization") end
	end,
}

commands.mr_maplist = {
	adminonly = true,
	run = function(p)
		local maps = urmain.var.maprandom.maps 
		local maplist = ""
		for f = 1,#maps do
			if maplist != "" then maplist = $1.."," end
			if maps[f] == gamemap then
				maplist = $1.."\x82"..G_BuildMapName(maps[f]).."\x80"
			else
				maplist = $1..G_BuildMapName(maps[f])
			end
		end
		CONS_Printf(p,"Map list: "..maplist)
	end,
}

commands.pr_enable = {
	adminonly = true,
	run = function(p,str)
		local aa = generalyn(str,urmain.var.physrandom.isenabled,p)
		if aa then urmain.var.physrandom.isenabled = 1
		elseif aa == false then urmain.var.physrandom.isenabled = 0
		else CONS_Printf(p,"ur pr_enable <0/1> - enable or disable Physics Randomizer") end
	end,
}

commands.pr_time = {
	adminonly = true,
	run = function(p,time)
		time = tonumber(time)
		if not time then 
			CONS_Printf(p,"Current value: "..tostring(urmain.var.physrandom.phtime))
			CONS_Printf(p,"ur pr_time <0-3600> - set time between physics changes (PR)")
			return 
		end
		if time < 1 then time = 1 elseif time > 3600 then time = 3600 end
		urmain.var.physrandom.phtime = time
	end,
}

commands.pr_randomspeed = {
	adminonly = true,
	run = function(p,str)
		if str == "0" or str == "normal" then
			urmain.var.physrandom.speed = 0
		elseif str == "1" or str == "limited" then
			urmain.var.physrandom.speed = 1
		elseif str == "2" or str == "full" then
			urmain.var.physrandom.speed = 2
		else
			CONS_Printf(p,"ur pr_randomspeed <0-normal/1-limited/2-full> - select the player speed and acceleration randomization mode")
		end
	end
}

commands.pr_randomdash = {
	adminonly = true,
	run = function(p,str)
		if str == "0" or str == "normal" then
			urmain.var.physrandom.spindash = 0
		elseif str == "1" or str == "limited" then
			urmain.var.physrandom.spindash = 1
		elseif str == "2" or str == "full" then
			urmain.var.physrandom.spindash = 2
		else
			CONS_Printf(p,"ur pr_randomdash <0-normal/1-limited/2-full> - select the spindash speed randomization mode")
		end
	end
}

commands.pr_randomfriction = {
	adminonly = true,
	run = function(p,str)
		if str == "0" or str == "normal" then
			urmain.var.physrandom.friction = 0
		elseif str == "1" or str == "limited" then
			urmain.var.physrandom.friction = 1
		elseif str == "2" or str == "full" then
			urmain.var.physrandom.friction = 2
		else
			CONS_Printf(p,"ur pr_randomfriction <0-normal/1-limited/2-full> - select the player friction randomization mode")
		end
	end
}

commands.pr_randomjump = {
	adminonly = true,
	run = function(p,str)
		if str == "0" or str == "normal" then
			urmain.var.physrandom.jumping = 0
		elseif str == "1" or str == "limited" then
			urmain.var.physrandom.jumping = 1
		elseif str == "2" or str == "full" then
			urmain.var.physrandom.jumping = 2
		else
			CONS_Printf(p,"ur pr_randomjump <0-normal/1-limited/2-full> - select the player jump height randomization mode")
		end
	end
}

commands.pr_randomactionspd = {
	adminonly = true,
	run = function(p,str)
		if str == "0" or str == "normal" then
			urmain.var.physrandom.actionspd = 0
		elseif str == "1" or str == "limited" then
			urmain.var.physrandom.actionspd = 1
		elseif str == "2" or str == "full" then
			urmain.var.physrandom.actionspd = 2
		else
			CONS_Printf(p,"ur pr_randomactionspd <0-normal/1-limited/2-full> - select the player action speed (for example thok) randomization mode")
		end
	end
}

commands.pr_showtimer = {
	adminonly = true,
	run = function(p,str)
		local aa = generalyn(str,urmain.var.physrandom.showtimer,p)
		if aa then urmain.var.physrandom.showtimer = 1
		elseif aa == false then urmain.var.physrandom.showtimer = 0
		else CONS_Printf(p,"ur pr_showtimer <0/1> - enable or disable timer (PR)") end
	end,
}

commands.misc_randtexture = {
	adminonly = true,
	run = function(p,str)
		if str == "0" or str == "normal" then
			urmain.var.miscrandom.texturerand = 0
		elseif str == "1" or str == "swap" then
			urmain.var.miscrandom.texturerand = 1
		elseif str == "2" or str == "randomize" then
			urmain.var.miscrandom.texturerand = 2
		else
			CONS_Printf(p,"ur misc_randtexture <0-normal/1-swap/2-randomize> - select the wall texture randomization mode")
		end
	end
}

commands.misc_randflat = {
	adminonly = true,
	run = function(p,str)
		if str == "0" or str == "normal" then
			urmain.var.miscrandom.flatrand = 0
		elseif str == "1" or str == "swap" then
			urmain.var.miscrandom.flatrand = 1
		elseif str == "2" or str == "randomize" then
			urmain.var.miscrandom.flatrand = 2
		else
			CONS_Printf(p,"ur misc_randflat <0-normal/1-swap/2-randomize> - select the flat randomization mode")
		end
	end
}

commands.misc_randbrightness = {
	adminonly = true,
	run = function(p,str)
		if str == "0" or str == "off" then
			urmain.var.miscrandom.brightrand = 0
		elseif str == "1" or str == "relative" then
			urmain.var.miscrandom.brightrand = 1
		elseif str == "2" or str == "absolute" then
			urmain.var.miscrandom.brightrand = 2
		else
			CONS_Printf(p,"ur misc_randbrightness <0-off/1-relative/2-absolute> - select the brightness randomization mode")
		end
	end,
}

commands.misc_randcolor = {
	adminonly = true,
	run = function(p,str)
		local aa = generalyn(str,urmain.var.miscrandom.colorrand,p)
		if aa then urmain.var.miscrandom.colorrand = 1
		elseif aa == false then urmain.var.miscrandom.colorrand = 0
		else CONS_Printf(p,"ur misc_randcolor <0/1> - enable or disable color randomization") end
	end,
}

commands.misc_randability = {
	adminonly = true,
	run = function(p,str)
		local aa = generalyn(str,urmain.var.miscrandom.abilityrand,p)
		if aa then urmain.var.miscrandom.abilityrand = 1
		elseif aa == false then urmain.var.miscrandom.abilityrand = 0
		else CONS_Printf(p,"ur misc_randability <0/1> - enable or disable character ability randomization") end
	end,
}

commands.misc_randsky = {
	adminonly = true,
	run = function(p,str)
		local aa = generalyn(str,urmain.var.miscrandom.skyrand,p)
		if aa then urmain.var.miscrandom.skyrand = 1
		elseif aa == false then urmain.var.miscrandom.skyrand = 0
		else CONS_Printf(p,"ur misc_randsky <0/1> - enable or disable sky texture randomization") end
	end,
}

COM_AddCommand("ur",function(p,cmd,...)
	local args = {...}
	if not cmd then
		CONS_Printf(p,"ur <command> <arguments> - set various Ultimate Randomizer things")
	else
		if not commands[cmd] then 
			CONS_Printf(p,"Unknown command '"..cmd.."'")
		else 
			//if commands[cmd].adminonly and not playeradmin(p) then 
				//CONS_Printf(p,"Only the server or a remote admin can use this.")
			//else
				commands[cmd].run(p,unpack(args))
			//end
		end
	end
end, 1) //Admin-Only because all commands have "adminonly" variable set to true

commands.loadconfig = {
	adminonly = true,
	run = function(p,name)
		if p ~= consoleplayer then return end
		if not name or string.sub(name,-4,-1) ~= ".cfg" then 
			if p then
				CONS_Printf(p,"Invalid config name ("..tostring(name)..")!")
			end
			return 
		end
		local lcfg = io.openlocal("client/ultrand/"..name,"r")
		if not lcfg then
			if p then
				CONS_Printf(p,"Can't load config '"..name.."'!")
				return
			else
				return "\x85".."Can't load config \x87"..name.."\x85!\x80"
			end
		end
		local str = lcfg:read("*l")
		while str do
			addToCmdQueue(str)
			str = lcfg:read("*l")
		end
	end
}

commands.saveconfig = {
	adminonly = true,
	run = function(p,name)
		if p ~= consoleplayer then return end
		if not name or name == ".cfg" then name = "URConf"..tostring(P_RandomRange(1,65535))..tostring(P_RandomRange(0,65535))..".cfg" end
		local scfg = io.openlocal("client/ultrand/"..name,"w")
		if not scfg then
			if p then
				CONS_Printf(p,"Can't save config '"..name.."'!")
				return
			else
				return "\x85".."Can't save config \x87"..name.."\x85!\x80"
			end
		end
		local mainv = urmain.var.main
		local chrand = urmain.var.charrandom
		local obrand = urmain.var.objrandom
		local maprand = urmain.var.maprandom
		local phrand = urmain.var.physrandom
		local miscrand = urmain.var.miscrandom
		
		//Ultimate Randomizer V2 config format, adjusted to load everything in a correct order

		//Ultimate Randomizer seed
		scfg:write("ur_setseed "..tostring(mainv.seed).."\n")
		//Ultimate Randomizer config values
		scfg:write("ur cr_time "..tostring(chrand.crtime).."\n")
		scfg:write("ur cr_ultimate "..tostring(chrand.ultimate).."\n")
		scfg:write("ur cr_sa2random "..tostring(chrand.sa2random).."\n")
		scfg:write("ur cr_timeoffset "..tostring(chrand.timeoffset).."\n")
		scfg:write("ur cr_shownextskin "..tostring(chrand.shownextskin).."\n")
		scfg:write("ur cr_showtimer "..tostring(chrand.showtimer).."\n")
		scfg:write("ur or_setposition "..tostring(obrand.setposition).."\n")
		scfg:write("ur or_randomtype "..tostring(obrand.randomtype).."\n")
		scfg:write("ur or_randomsize "..tostring(obrand.randomsize).."\n")
		scfg:write("ur or_randomrings "..tostring(obrand.randomrings).."\n")
		scfg:write("ur mr_bossmaps "..tostring(maprand.bossmaps).."\n")
		scfg:write("ur mr_specialstages "..tostring(maprand.specialstages).."\n")
		scfg:write("ur mr_autorandomize "..tostring(maprand.autorandom).."\n")
		scfg:write("ur pr_time "..tostring(phrand.phtime).."\n")
		scfg:write("ur pr_randomspeed "..tostring(phrand.speed).."\n")
		scfg:write("ur pr_randomdash "..tostring(phrand.spindash).."\n")
		scfg:write("ur pr_randomfriction "..tostring(phrand.friction).."\n")
		scfg:write("ur pr_randomjump "..tostring(phrand.jumping).."\n")
		scfg:write("ur pr_randomactionspd "..tostring(phrand.actionspd).."\n")
		scfg:write("ur pr_showtimer "..tostring(phrand.showtimer).."\n")
		scfg:write("ur misc_randtexture "..tostring(miscrand.texturerand).."\n")
		scfg:write("ur misc_randflat "..tostring(miscrand.flatrand).."\n")
		scfg:write("ur misc_randcolor "..tostring(miscrand.colorrand).."\n")
		scfg:write("ur misc_randbrightness "..tostring(miscrand.brightrand).."\n")
		scfg:write("ur misc_randability "..tostring(miscrand.abilityrand).."\n")
		scfg:write("ur misc_randsky "..tostring(miscrand.skyrand).."\n")
		//Ultimate Randomizer enable values, Map Randomizer is last because it can change the map when enabled
		scfg:write("ur cr_enable "..tostring(chrand.isenabled).."\n")
		scfg:write("ur or_enable "..tostring(obrand.isenabled).."\n")
		scfg:write("ur pr_enable "..tostring(phrand.isenabled).."\n")
		scfg:write("ur mr_enable "..tostring(maprand.isenabled).."\n")
		//Message to show that everything has been loaded (it takes around a second for the config to load)
		scfg:write(string.format("echo \"%s (UR v2) has been loaded!\"\n",name))
		scfg:close()
		if p then 
			CONS_Printf(p,"Config file '"..name.."' has been saved to luafiles directory!")
		else
			return "\x83"..name.."\x82 saved!\x80"
		end 
	end
}

commands.hidemenu = {
	adminonly = true,
	run = function(p)
		p.urhudon = false
	end
}

COM_AddCommand("ur_saveconfig",commands.saveconfig.run, 1) //Alias to "ur saveconfig"

COM_AddCommand("ur_loadconfig",commands.loadconfig.run, 1) //Alias to "ur loadconfig"

COM_AddCommand("ur_resetsettings",function(p)
	urmain.setupVariables()
	CONS_Printf(p,"Settings have been reset!")
end, 1)

COM_AddCommand("ur_setseed",function(p,seed)
	if seed then
		if tonumber(seed) ~= nil then seed = tonumber(seed) else seed = seed:sub(1,16) end
		urmain.randomSeed(seed)
		CONS_Printf(p,"Random seed set to "..tostring(urmain.var.main.seed))
	else 
		CONS_Printf(p,"ur_setseed <seed> - set the RNG seed (0 - fully random)")
		CONS_Printf(p,"The seed can either be a number or a string.")
		CONS_Printf(p,"Current seed: "..tostring(urmain.var.main.seed))
	end
end, 1)

COM_AddCommand("ur_showmenu",function(p)
	p.urhudon = true
end, 1)

addHook("PlayerThink",function(p)
	if p == consoleplayer then
		execFromCmdQueue(p)
	end
end)

urmain.cmds = commands
