--Ultimate Randomizer HUD Menu
--Made by Nightwolf

local urmain = assert(_URANDOM,"URANDOM: variables.lua isn't loaded properly!")

local HUDX = 40
local HUDY = 20
local HUDWINWIDTH = 240 //Maximum 320
local HUDWINHEIGHT = 160 //Maximum 200
local HUDTEXTHEIGHT = 16 //Height between HUD texts
local MAXELEMENTS = (HUDWINHEIGHT/HUDTEXTHEIGHT)-2 //Currently 8

local HBUTTON_UP = 1
local HBUTTON_DOWN = 2
local HBUTTON_JUMP = 3
local HBUTTON_SPIN = 4

local urhud = nil //Local player's HUD

local isInput = false
local isKeyInput = false //Captures key names instead of characters
local hInputTab = {str = "", isNumber = false, spaces = false, curChar = 1, insertMode = false, endFunc = nil}
local inputRepeatTab = {isRepeat = false, key = nil, timer = 0}

local inputBanChars = {
	["\\"] = true,
	["/"] = true
}

local function selsound()
	S_StartSound(nil,sfx_menu1,p)
end

local function playeradmin(p)
	return (p == server or IsPlayerAdmin(p) or not netgame)
end

local function listnext(list)
	if type(list) != "table" return end
	if not list.selection then list.selection = 1 end
	if list.selection < #list.contents then
		list.selection = $1 + 1
	else
		list.selection = 1
	end
	selsound()
end

local function listprev(list)
	if type(list) != "table" return end
	if not list.selection then list.selection = 1 end
	if list.selection < 2 then
		list.selection = #list.contents
	else
		list.selection = $1 - 1
	end
	selsound()
end

local function resetInput()
	isInput = false
	isKeyInput = false
	hInputTab = {str = "", isNumber = false, spaces = false, curChar = 1, insertMode = false, endFunc = nil}
	inputRepeatTab = {isRepeat = false, key = nil, timer = 0}
end

--If quitPastLimit is true, moving forward past the character limit will stop text input
local function moveInput(back,quitPastLimit)
	local begPos = 0
	if hInputTab.insertMode then begPos = 1 end
	if back then
		hInputTab.curChar = $ - 1
		if hInputTab.curChar < begPos then
			hInputTab.curChar = hInputTab.str:len()
		end
	else
		hInputTab.curChar = $ + 1
		if hInputTab.curChar > hInputTab.str:len() then
			hInputTab.curChar = begPos
			if quitPastLimit then
				if hInputTab.endFunc then hInputTab.endFunc() end
				resetInput()
				return true
			end
		end
	end
end

local function makeInputString(addStr, addStrPos)
	local str = hInputTab.str
	local charpos = hInputTab.curChar
	if addStr and addStrPos then
		str = str:sub(1,addStrPos)..addStr..str:sub(addStrPos+1,-1)
		if charpos > addStrPos then charpos = $+addStr:len() end
	end
	if hInputTab.insertMode then
		str = str:sub(1,charpos-1).."\x87"..str:sub(charpos,charpos).."\x83"..str:sub(charpos+1,-1)
	else
		str = str:sub(1,charpos).."\x87|\x83"..str:sub(charpos+1,-1)
	end
	return "\x83"..str
end

local function clistmove(num,limit,fwd)
	if not num or not limit then return 1 end
	if fwd then
		if num < limit then return num+1 else return 1 end
	else
		if num < 2 then return limit else return num-1 end
	end
end

local function reversenum(var)
	if var == 0 or var == false then
		return 1
	else
		return 0
	end
end

local function changelnum(huddata,num)
	if not huddata then return end
	if not num then num = 1 end
	huddata.listnum = num
	huddata.selection = 1
end

local hudcontents = {}
hudcontents[1] = {}
hudcontents[1][1] = {
	startstring = "\x88".."Ultimate Randomizer menu",
	string = "Character Randomizer",
	go = function(huddata)
		changelnum(huddata,2)
	end,
	back = function(huddata)
		huddata.selection = -1
	end,
}
hudcontents[1][2] = {
	string = "Object Randomizer",
	go = function(huddata)
		changelnum(huddata,3)
	end,
	back = function(huddata)
		huddata.selection = -1
	end,
}
hudcontents[1][3] = {
	string = "Map Randomizer",
	go = function(huddata)
		changelnum(huddata,4)
	end,
	back = function(huddata)
		huddata.selection = -1
	end,
}
hudcontents[1][4] = {
	string = "Physics Randomizer",
	go = function(huddata)
		changelnum(huddata,5)
	end,
	back = function(huddata)
		huddata.selection = -1
	end,
}
hudcontents[1][5] = {
	string = "Misc. Randomizer",
	go = function(huddata)
		changelnum(huddata,6)
	end,
	back = function(huddata)
		huddata.selection = -1
	end,
}
hudcontents[1][6] = {
	string = "Random seed",
	go = function(huddata,self)
		isInput = true
		if urmain.var.main.seed == 0 then
			hInputTab.str = ""
		else
			hInputTab.str = tostring(urmain.var.main.seed)
		end
		hInputTab.insertMode = false
		hInputTab.spaces = false
		hInputTab.isNumber = false
		hInputTab.curChar = hInputTab.str:len()
		hInputTab.endFunc = function()
			if hInputTab.str == "" then
				COM_BufInsertText(huddata.player,"ur_setseed 0")
			else
				COM_BufInsertText(huddata.player,"ur_setseed "..hInputTab.str)
			end
		end
	end,
	back = function(huddata)
		huddata.selection = -1
	end,
	printstr = function(huddata,self)
		local rstr = ""
		if isInput and huddata.selection == 6 then
			rstr = makeInputString()
		elseif urmain.var.main.seed == 0 then
			rstr = "\x82None (random)"
		else
			rstr = "\x82"..tostring(urmain.var.main.seed)
		end
		return rstr
	end,
}
hudcontents[1][7] = {
	string = "UltRandom Settings",
	go = function(huddata)
		changelnum(huddata,7)
	end,
	back = function(huddata)
		huddata.selection = -1
	end,
}
//Start of menu option definitions
hudcontents[2] = {}
hudcontents[2][1] = {
	startstring = "\x88".."Character randomizer options",
	string = "Enable",
	go = function(huddata)
		COM_BufInsertText(huddata.player,"ur cr_enable "..reversenum(urmain.var.charrandom.isenabled))
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		if urmain.var.charrandom.isenabled == 0 then return "\x85".."NO" else return "\x83".."YES" end
	end,
}
hudcontents[2][2] = {
	string = "Skin Time",
	selpart = 0,
	issel = false,
	go = function(huddata,self)
		isInput = true
		local tictime = urmain.var.charrandom.crtime * TICRATE
		hInputTab.str = string.format("%02d%02d",tostring(G_TicsToMinutes(tictime,true)),tostring(G_TicsToSeconds(tictime)))
		hInputTab.insertMode = true
		hInputTab.spaces = false
		hInputTab.isNumber = true
		hInputTab.curChar = 1
		hInputTab.endFunc = function()
			local crtime = min(tonumber(hInputTab.str:sub(1,2)),59)*60 + min(tonumber(hInputTab.str:sub(3,4)),59)
			crtime = max($,1)
			COM_BufInsertText(huddata.player,"ur cr_time "..crtime)
		end
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata,self)
		local tictime = urmain.var.charrandom.crtime * TICRATE
		local rstr = ""
		if isInput and huddata.selection == 2 then
			rstr = makeInputString("\x82:\x83",2)
		else
			rstr = string.format("\x82%d:%02d",tostring(G_TicsToMinutes(tictime,true)),tostring(G_TicsToSeconds(tictime)))
		end
		return rstr
	end,
}
hudcontents[2][3] = {
	string = "Ultimate mode",
	go = function(huddata)
		COM_BufInsertText(huddata.player,"ur cr_ultimate "..reversenum(urmain.var.charrandom.ultimate))
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		if urmain.var.charrandom.ultimate == 0 then return "\x85".."Disabled" else return "\x83".."Enabled" end
	end,
}
hudcontents[2][4] = {
	string = "SA2 Rando Mode",
	go = function(huddata)
		COM_BufInsertText(huddata.player,"ur cr_sa2random "..reversenum(urmain.var.charrandom.sa2random))
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		if urmain.var.charrandom.sa2random == 0 then return "\x85".."Disabled" else return "\x83".."Enabled" end
	end,
}
hudcontents[2][5] = {
	string = "Skin Time Offset",
	selpart = 0,
	issel = false,
	go = function(huddata,self)
		isInput = true
		local tictime = urmain.var.charrandom.timeoffset * TICRATE
		hInputTab.str = string.format("%02d%02d",tostring(G_TicsToMinutes(tictime,true)),tostring(G_TicsToSeconds(tictime)))
		hInputTab.insertMode = true
		hInputTab.spaces = false
		hInputTab.isNumber = true
		hInputTab.curChar = 1
		hInputTab.endFunc = function()
			local crtimeoffset = min(tonumber(hInputTab.str:sub(1,2)),59)*60 + min(tonumber(hInputTab.str:sub(3,4)),59)
			COM_BufInsertText(huddata.player,"ur cr_timeoffset "..crtimeoffset)
		end
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata,self)
		local tictime = urmain.var.charrandom.timeoffset * TICRATE
		local rstr = ""
		if isInput and huddata.selection == 5 then
			rstr = makeInputString("\x82:\x83",2)
		else
			rstr = string.format("\x82%d:%02d",tostring(G_TicsToMinutes(tictime,true)),tostring(G_TicsToSeconds(tictime)))
		end
		return rstr
	end,
}
hudcontents[2][6] = {
	string = "Show next skin",
	go = function(huddata)
		COM_BufInsertText(huddata.player,"ur cr_shownextskin "..reversenum(urmain.var.charrandom.shownextskin))
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		if urmain.var.charrandom.shownextskin == 0 then return "\x85".."Disabled" else return "\x83".."Enabled" end
	end,
}
hudcontents[2][7] = {
	string = "Show skin timer",
	go = function(huddata)
		COM_BufInsertText(huddata.player,"ur cr_showtimer "..reversenum(urmain.var.charrandom.showtimer))
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		if urmain.var.charrandom.showtimer == 0 then return "\x85".."Disabled" else return "\x83".."Enabled" end
	end,
}
hudcontents[3] = {}
hudcontents[3][1] = {
	startstring = "Object Randomizer options",
	string = "Enable",
	go = function(huddata)
		COM_BufInsertText(huddata.player,"ur or_enable "..reversenum(urmain.var.objrandom.isenabled))
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		if urmain.var.objrandom.isenabled == 0 then return "\x85".."NO" else return "\x83".."YES" end
	end,
}
hudcontents[3][2] = {
	string = "Object Position",
	go = function(huddata)
		local setposition = urmain.var.objrandom.setposition
		if setposition < 2 then setposition = $1 + 1 else setposition = 0 end
		COM_BufInsertText(huddata.player,"ur or_setposition "..setposition)
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		local sp = urmain.var.objrandom.setposition
		if sp == 0 then return "\x82".."Normal" elseif sp == 1 return "\x82".."Swap" elseif sp == 2 return "\x82".."Random" end
		return "\x8f".."error"
	end,
}
hudcontents[3][3] = {
	string = "Type randomization",
	go = function(huddata)
		local randomtype = urmain.var.objrandom.randomtype
		if randomtype < 4 then randomtype = $1 + 1 else randomtype = 0 end
		COM_BufInsertText(huddata.player,"ur or_randomtype "..randomtype)
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		local rt = urmain.var.objrandom.randomtype
		if rt == 0 then return "\x82".."Disabled" elseif rt == 1 then return "\x82".."Limited" elseif rt == 2 then return "\x82".."Uniform" elseif rt == 3 then return "\x82".."Smart" elseif rt == 4 then return "\x82".."Full" end
		return "\x8f".."error"
	end,
}
hudcontents[3][4] = {
	string = "Size randomization",
	go = function(huddata)
		local randomsize = urmain.var.objrandom.randomsize
		if randomsize < 2 then randomsize = $1 + 1 else randomsize = 0 end
		COM_BufInsertText(huddata.player,"ur or_randomsize "..randomsize)
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		local rt = urmain.var.objrandom.randomsize
		if rt == 0 then return "\x82".."Disabled" elseif rt == 1 then return "\x82".."Limited" elseif rt == 2 then return "\x82".."Max" end
		return "\x8f".."error"
	end,
}
hudcontents[3][5] = {
	string = "Include rings",
	go = function(huddata)
		COM_BufInsertText(huddata.player,"ur or_randomrings "..reversenum(urmain.var.objrandom.randomrings))
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		if urmain.var.objrandom.randomrings == 0 then return "\x85".."No" else return "\x83".."Yes" end
	end,
}

hudcontents[4] = {}
hudcontents[4][1] = {
	startstring = "Map Randomizer options",
	string = "Enable",
	go = function(huddata)
		COM_BufInsertText(huddata.player,"ur mr_enable "..reversenum(urmain.var.maprandom.isenabled))
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	up = function(huddata)
		huddata.selection = 5
		selsound()
	end,
	printstr = function(huddata)
		if urmain.var.maprandom.isenabled == 0 then return "\x85".."NO" else return "\x83".."YES" end
	end,
}
hudcontents[4][2] = {
	string = "Boss Maps",
	go = function(huddata)
		COM_BufInsertText(huddata.player,"ur mr_bossmaps "..reversenum(urmain.var.maprandom.bossmaps))
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		if urmain.var.maprandom.bossmaps == 0 then return "\x85".."Disabled" else return "\x83".."Enabled" end
	end,
}
hudcontents[4][3] = {
	string = "Special Stages",
	go = function(huddata)
		COM_BufInsertText(huddata.player,"ur mr_specialstages "..reversenum(urmain.var.maprandom.specialstages))
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		if urmain.var.maprandom.specialstages == 0 then return "\x85".."Disabled" else return "\x83".."Enabled" end
	end,
}
hudcontents[4][4] = {
	string = "Auto-randomize",
	go = function(huddata)
		COM_BufInsertText(huddata.player,"ur mr_autorandomize "..reversenum(urmain.var.maprandom.autorandom))
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		if urmain.var.maprandom.autorandom == 0 then return "\x85".."Disabled" else return "\x83".."Enabled" end
	end,
}
hudcontents[4][5] = {
	string = "RANDOMIZE!",
	go = function(huddata)
		COM_BufInsertText(huddata.player,"ur mr_randomize")
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	down = function(huddata)
		huddata.selection = 1
		selsound()
	end,
	printstr = function(huddata)
		return ""
	end,
}
hudcontents[4][6] = {
	string = "",
	go = function(huddata)
		return
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		return ""
	end,
}
hudcontents[4][7] = {
	string = "\x82".."Current: ",
	go = function(huddata)
		return
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		local vars = urmain.var.maprandom
		if vars.isenabled == 0 then return "\x85".."Disabled" end
		if #vars.maps == 0 then return "None" end
		if vars.maps[vars.mapnum] then return G_BuildMapTitle(vars.maps[vars.mapnum]) end
		return "None"
	end,
}
hudcontents[4][8] = {
	string = "\x82".."Next: ",
	go = function(huddata)
		return
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		local vars = urmain.var.maprandom
		if vars.isenabled == 0 then return "\x85".."Disabled" end
		if #vars.maps == 0 or #vars.maps <= vars.mapnum then return "None" end
		if vars.maps[vars.mapnum+1] then return G_BuildMapTitle(vars.maps[vars.mapnum+1]) end
		return "None"
	end,
}
hudcontents[5] = {}
hudcontents[5][1] = {
	startstring = "Physics Randomizer options",
	string = "Enable",
	go = function(huddata)
		COM_BufInsertText(huddata.player,"ur pr_enable "..reversenum(urmain.var.physrandom.isenabled))
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		if urmain.var.physrandom.isenabled == 0 then return "\x85".."NO" else return "\x83".."YES" end
	end,
}
hudcontents[5][2] = {
	string = "Cooldown",
	selpart = 0,
	issel = false,
	go = function(huddata,self)
		isInput = true
		local tictime = urmain.var.physrandom.phtime * TICRATE
		hInputTab.str = string.format("%02d%02d",tostring(G_TicsToMinutes(tictime,true)),tostring(G_TicsToSeconds(tictime)))
		hInputTab.insertMode = true
		hInputTab.spaces = false
		hInputTab.isNumber = true
		hInputTab.curChar = 1
		hInputTab.endFunc = function()
			local phtime = min(tonumber(hInputTab.str:sub(1,2)),59)*60 + min(tonumber(hInputTab.str:sub(3,4)),59)
			COM_BufInsertText(huddata.player,"ur pr_time "..phtime)
		end
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata,self)
		local tictime = urmain.var.physrandom.phtime * TICRATE
		local rstr = ""
		if isInput and huddata.selection == 2 then
			rstr = makeInputString("\x82:\x83",2)
		else
			rstr = string.format("\x82%d:%02d",tostring(G_TicsToMinutes(tictime,true)),tostring(G_TicsToSeconds(tictime)))
		end
		return rstr
	end,
}
hudcontents[5][3] = {
	string = "Random Speed",
	go = function(huddata)
		local speed = urmain.var.physrandom.speed
		if speed < 2 then speed = $1 + 1 else speed = 0 end
		COM_BufInsertText(huddata.player,"ur pr_randomspeed "..speed)
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		local sp = urmain.var.physrandom.speed
		if sp == 0 then return "\x82".."Disabled" elseif sp == 1 return "\x82".."Limited" elseif sp == 2 return "\x82".."Full" end
		return "\x8f".."error"
	end,
}
hudcontents[5][4] = {
	string = "Random Spindash",
	go = function(huddata)
		local spindash = urmain.var.physrandom.spindash
		if spindash < 2 then spindash = $1 + 1 else spindash = 0 end
		COM_BufInsertText(huddata.player,"ur pr_randomdash "..spindash)
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		local sp = urmain.var.physrandom.spindash
		if sp == 0 then return "\x82".."Disabled" elseif sp == 1 return "\x82".."Limited" elseif sp == 2 return "\x82".."Full" end
		return "\x8f".."error"
	end,
}
hudcontents[5][5] = {
	string = "Random Friction",
	go = function(huddata)
		local friction = urmain.var.physrandom.friction
		if friction < 2 then friction = $1 + 1 else friction = 0 end
		COM_BufInsertText(huddata.player,"ur pr_randomfriction "..friction)
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		local th = urmain.var.physrandom.friction
		if th == 0 then return "\x82".."Disabled" elseif th == 1 return "\x82".."Limited" elseif th == 2 return "\x82".."Full" end
		return "\x8f".."error"
	end,
}
hudcontents[5][6] = {
	string = "Random Jump",
	go = function(huddata)
		local jumping = urmain.var.physrandom.jumping
		if jumping < 2 then jumping = $1 + 1 else jumping = 0 end
		COM_BufInsertText(huddata.player,"ur pr_randomjump "..jumping)
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		local th = urmain.var.physrandom.jumping
		if th == 0 then return "\x82".."Disabled" elseif th == 1 return "\x82".."Limited" elseif th == 2 return "\x82".."Full" end
		return "\x8f".."error"
	end,
}
hudcontents[5][7] = {
	string = "Random ActionSpd",
	go = function(huddata)
		local actionspd = urmain.var.physrandom.actionspd
		if actionspd < 2 then actionspd = $1 + 1 else actionspd = 0 end
		COM_BufInsertText(huddata.player,"ur pr_randomactionspd "..actionspd)
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		local th = urmain.var.physrandom.actionspd
		if th == 0 then return "\x82".."Disabled" elseif th == 1 return "\x82".."Limited" elseif th == 2 return "\x82".."Full" end
		return "\x8f".."error"
	end,
}
hudcontents[5][8] = {
	string = "Show timer",
	go = function(huddata)
		COM_BufInsertText(huddata.player,"ur pr_showtimer "..reversenum(urmain.var.physrandom.showtimer))
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		if urmain.var.physrandom.showtimer == 0 then return "\x85".."Disabled" else return "\x83".."Enabled" end
	end,
}
hudcontents[6] = {}
hudcontents[6][1] = {
	startstring = "Misc. Randomizer options",
	string = "Random Texture",
	go = function(huddata)
		local texturerand = urmain.var.miscrandom.texturerand
		if texturerand < 2 then texturerand = $1 + 1 else texturerand = 0 end
		COM_BufInsertText(huddata.player,"ur misc_randtexture "..texturerand)
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		local sp = urmain.var.miscrandom.texturerand
		if sp == 0 then return "\x82".."Disabled" elseif sp == 1 return "\x82".."Swap" elseif sp == 2 return "\x82".."Randomize" end
		return "\x8f".."error"
	end,
}
hudcontents[6][2] = {
	string = "Random Flat",
	go = function(huddata)
		local flatrand = urmain.var.miscrandom.flatrand
		if flatrand < 2 then flatrand = $1 + 1 else flatrand = 0 end
		COM_BufInsertText(huddata.player,"ur misc_randflat "..flatrand)
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		local sp = urmain.var.miscrandom.flatrand
		if sp == 0 then return "\x82".."Disabled" elseif sp == 1 return "\x82".."Swap" elseif sp == 2 return "\x82".."Randomize" end
		return "\x8f".."error"
	end,
}
hudcontents[6][3] = {
	string = "Random Brightness",
	go = function(huddata)
		local brightrand = urmain.var.miscrandom.brightrand
		if brightrand < 2 then brightrand = $1 + 1 else brightrand = 0 end
		COM_BufInsertText(huddata.player,"ur misc_randbrightness "..brightrand)
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		local sp = urmain.var.miscrandom.brightrand
		if sp == 0 then return "\x82".."Disabled" elseif sp == 1 return "\x82".."Relative" elseif sp == 2 return "\x82".."Absolute" end
		return "\x8f".."error"
	end,
}
hudcontents[6][4] = {
	string = "Random Color",
	go = function(huddata)
		COM_BufInsertText(huddata.player,"ur misc_randcolor "..reversenum(urmain.var.miscrandom.colorrand))
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		if urmain.var.miscrandom.colorrand == 0 then return "\x85".."Disabled" else return "\x83".."Enabled" end
	end,
}
hudcontents[6][5] = {
	string = "Random Ability",
	go = function(huddata)
		reversenum(urmain.var.miscrandom,"abilityrand")
		COM_BufInsertText(huddata.player,"ur misc_randability "..reversenum(urmain.var.miscrandom.abilityrand))
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		if urmain.var.miscrandom.abilityrand == 0 then return "\x85".."Disabled" else return "\x83".."Enabled" end
	end,
}
hudcontents[6][6] = {
	string = "Random Sky Texture",
	go = function(huddata)
		reversenum(urmain.var.miscrandom,"skyrand")
		COM_BufInsertText(huddata.player,"ur misc_randsky "..reversenum(urmain.var.miscrandom.skyrand))
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		if urmain.var.miscrandom.skyrand == 0 then return "\x85".."Disabled" else return "\x83".."Enabled" end
	end,
}
hudcontents[7] = {}
hudcontents[7][1] = {
	startstring = "UltRandom Settings",
	string = "Filename",
	go = function(huddata,self)
		isInput = true
		hInputTab.str = urmain.lastCfg
		hInputTab.insertMode = false
		hInputTab.spaces = false
		hInputTab.isNumber = false
		hInputTab.curChar = hInputTab.str:len()
		hInputTab.endFunc = function()
			if hInputTab.str != "" then
				urmain.lastCfg = hInputTab.str
			else
				urmain.lastCfg = "default"
			end
		end
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata,self)
		local rstr = ""
		if isInput and huddata.selection == 1 then
			rstr = makeInputString()
		else
			rstr = string.format("\x82%s.cfg",urmain.lastCfg)
		end
		return rstr
	end,
}
hudcontents[7][2] = {
	string = "Save config",
	go = function(huddata)
		urmain.cmds.saveconfig.run(huddata.player,urmain.lastCfg..".cfg")
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
}
hudcontents[7][3] = {
	string = "Load config",
	go = function(huddata)
		urmain.cmds.loadconfig.run(huddata.player,urmain.lastCfg..".cfg")
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	down = function(huddata)
		listnext(huddata)
		listnext(huddata)
	end,
}
hudcontents[7][4] = {
	string = "",
	go = function(huddata)
		return
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
}
hudcontents[7][5] = {
	string = "Reset settings",
	go = function(huddata)
		COM_BufInsertText(huddata.player,"ur_resetsettings")
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	up = function(huddata)
		listprev(huddata)
		listprev(huddata)
	end,
}

//End of menu option definitions

//Credit to Flame for the 3 lines of code below
addHook("JumpSpecial", function(p) return p.urhudon end)
addHook("SpinSpecial", function(p) return p.urhudon end)
addHook("JumpSpinSpecial", function(p) return p.urhudon end)

addHook("PlayerCmd",function(p,cmd)
	if p.urhudon then
		cmd.angleturn = (p.mo.angle>>16)-1 //For some reason, that -1 is required
		cmd.aiming = p.aiming>>16
		cmd.forwardmove = 0
		cmd.sidemove = 0
		cmd.buttons = 0
	end
end)

addHook("PlayerThink",function(p)
	if p == consoleplayer then
		if not p.urhudon then 
			if urhud then
				urhud = nil
				resetInput()
			end
			return 
		end
		if not urhud then
			urhud = {} 
			urhud.selection = 1
			urhud.listnum = 1
			urhud.pressed = 0
			urhud.player = p
			resetInput()
		end
		urhud.contents = hudcontents[urhud.listnum]
		if urhud.selection < 0 then
			COM_BufInsertText(consoleplayer,"ur hidemenu")
			urhud = nil
			resetInput()
			return
		end
	end
end)

local function writeChar(kevent)
	if hInputTab.spaces and kevent.name == "space" then
		hInputTab.str = $:sub(1,hInputTab.curChar).." "..$:sub(hInputTab.curChar+1,-1)
		moveInput(false)
	elseif hInputTab.curChar > 0 and hInputTab.str:len() > 0 and kevent.name == "backspace" then
		hInputTab.str = $:sub(1,hInputTab.curChar-1)..$:sub(hInputTab.curChar+1,-1)
		moveInput(true)
	elseif kevent.name:len() == 1 then
		if not hInputTab.isNumber or (hInputTab.isNumber and tonumber(kevent.name) ~= nil) then
			hInputTab.str = $:sub(1,hInputTab.curChar)..kevent.name..$:sub(hInputTab.curChar+1,-1)
			moveInput(false)
		end
	end
end

local function textInputFunc(kevent)
	if inputBanChars[kevent.name] then return end
	if not kevent.repeated then
		if kevent.name == "left arrow" then
			moveInput(true)
		elseif kevent.name == "right arrow" then
			moveInput(false)
		elseif kevent.name == "enter" then
			if hInputTab.endFunc then hInputTab.endFunc() end
			resetInput()
		elseif hInputTab.insertMode then
			if hInputTab.str:len() == 0 then return end
			if hInputTab.spaces and kevent.name == "space" then
				hInputTab.str = $:sub(1,hInputTab.curChar-1).." "..$:sub(hInputTab.curChar+1,-1)
				moveInput(false,true)
			elseif kevent.name:len() == 1 then
				if not hInputTab.isNumber or (hInputTab.isNumber and tonumber(kevent.name) ~= nil) then
					hInputTab.str = $:sub(1,hInputTab.curChar-1)..kevent.name..$:sub(hInputTab.curChar+1,-1)
					moveInput(false,true)
				end
			end
		else
			writeChar(kevent)
		end
	elseif not hInputTab.insertMode then
		if not inputRepeatTab.isRepeat then
			inputRepeatTab.isRepeat = true
			inputRepeatTab.key = kevent.name
			inputRepeatTab.timer = -2
		elseif inputRepeatTab.key == kevent.name then
			if inputRepeatTab.timer >= 1 then
				if kevent.name == "left arrow" then
					moveInput(true)
				elseif kevent.name == "right arrow" then
					moveInput(false)
				else
					writeChar(kevent)
				end
				inputRepeatTab.timer = 0
			else
				inputRepeatTab.timer = $ + 1
			end
		end
	end
	if hInputTab.str:len() > 16 then
		hInputTab.str = $:sub(1,16)
		hInputTab.curChar = min($,16)
	end
end

local function menuInputFunc(kevent)
	local p = consoleplayer
	if not urhud or not urhud.contents then return end
	local sel = urhud.selection
	local cont = urhud.contents
	local sidemove = p.cmd.sidemove
	local fwdmove = p.cmd.forwardmove
	if not cont[sel] then 
		return 
	elseif kevent.num == input.gameControlToKeyNum(GC_FORWARD) or kevent.name == "up arrow" then
		urhud.pressed = HBUTTON_UP
		if cont[sel].up then cont[sel].up(urhud,cont[sel]) else listprev(urhud) end
	elseif kevent.num == input.gameControlToKeyNum(GC_BACKWARD) or kevent.name == "down arrow" then
		urhud.pressed = HBUTTON_DOWN
		if cont[sel].down then cont[sel].down(urhud,cont[sel]) else listnext(urhud) end
	elseif kevent.num == input.gameControlToKeyNum(GC_JUMP) or kevent.name == "enter" then
		urhud.pressed = HBUTTON_JUMP
		if cont[sel].go then cont[sel].go(urhud,cont[sel]) end
	elseif kevent.num == input.gameControlToKeyNum(GC_SPIN) then
		urhud.pressed = HBUTTON_SPIN
		if cont[sel].back then cont[sel].back(urhud,cont[sel]) end
		if urhud.listnum == 1 then return true end
	end
end

addHook("KeyDown",function(kevent)
	if consoleplayer and gamestate == GS_LEVEL then
		if consoleplayer.urhudon then
			if isKeyInput then
				hInputTab.str = kevent.name
				if hInputTab.endFunc then hInputTab.endFunc() end
				resetInput()
			elseif isInput then
				textInputFunc(kevent)
			elseif not kevent.repeated then
				if menuInputFunc(kevent) then return true end
			end
		end
	end
end)

addHook("KeyUp",function(kevent)
	if isInput and inputRepeatTab.isRepeat and inputRepeatTab.key == kevent.name then
		inputRepeatTab = {isRepeat = false, key = nil, timer = 0}
	end
end)

local function makeHintStr()
	if isInput then
		return string.format("Move with arrow keys, confirm with enter key")
	else
		return string.format("Press \x82%s \x80to go back.",input.keyNumToName(input.gameControlToKeyNum(GC_SPIN)))
	end
end

hud.add(function(v,p,cam)
	if not p.urhudon or not urhud then return end
	if not urhud.selection or not urhud.contents then return end
	if urhud.selection < 1 then return end
	if not v.urBgMiddleColor then v.urBgMiddleColor = v.cachePatch("~030") end
	if not v.urBgOutlineColor then v.urBgOutlineColor = v.cachePatch("~031") end
	if not v.urBgMiddleColor or not v.urBgOutlineColor then return end
	v.drawStretched(HUDX*FRACUNIT,HUDY*FRACUNIT,HUDWINWIDTH*1024,HUDWINHEIGHT*1024,v.urBgOutlineColor,V_30TRANS)
	v.drawStretched((HUDX+2)*FRACUNIT,(HUDY+2)*FRACUNIT,(HUDWINWIDTH-4)*1024,(HUDWINHEIGHT-4)*1024,v.urBgMiddleColor,V_50TRANS)
	local textx = HUDX+4 //X of value description (left border)
	local valuex = HUDX+HUDWINWIDTH-4 //X of value string (right border)
	local starttexty = HUDY+4 //Start Y of HUD text
	local startstr = hudcontents[urhud.listnum][1].startstring
	if urhud.contents[urhud.selection].startstring then startstr = urhud.contents[urhud.selection].startstring end
	v.drawString(HUDX+(HUDWINWIDTH/2),starttexty,"\x88"..tostring(startstr),0,"center")
	local elemy = starttexty+HUDTEXTHEIGHT //Start Y of first interactive element (changes in the next for loop)
	local elemlimit = min(#urhud.contents,MAXELEMENTS)
	for f = 1,elemlimit do
		if urhud.selection == f then v.drawString(textx,elemy,"\x82"..urhud.contents[f].string,0,"left")
		else v.drawString(textx,elemy,urhud.contents[f].string,0,"left") end
		if urhud.contents[f].printstr then v.drawString(valuex,elemy,urhud.contents[f].printstr(urhud,urhud.contents[f]),0,"right") end
		elemy = $1+HUDTEXTHEIGHT
	end
	v.drawString(HUDX+(HUDWINWIDTH/2),starttexty+HUDTEXTHEIGHT*(MAXELEMENTS+1)+2,makeHintStr(),0,"small-center")
end,"game")
