--Map Randomizer
--Made by Nightwolf

local urmain = assert(_URANDOM,"URANDOM: variables.lua isn't loaded properly!")
local vars = urmain.var.maprandom

local tempdisable = false

local justchanged = false

addHook("NetVars",function(net)
	tempdisable = net(tempdisable)
	justchanged = net(justchanged)
end)

local function getnextmap()
	return vars.maps[vars.mapnum+1] or vars.maps[1]
end

local function forcemapifwrong()
	if vars.isenabled == 0 or tempdisable or gamemap == titlemap return end
	if gamemap != vars.maps[vars.mapnum] then 
		G_SetCustomExitVars(vars.maps[vars.mapnum],2) 
		G_ExitLevel()
		tempdisable = true
		justchanged = true
		print("Map "..G_BuildMapName(gamemap).." should be "..G_BuildMapName(vars.maps[vars.mapnum])..", changing...")
	end
end

local function preparemap(p)
	if vars.mapnum >= #vars.maps then
		G_SetCustomExitVars(vars.maps[1],0)
	else
		G_SetCustomExitVars(vars.maps[vars.mapnum+1],0)
	end
	p.didexit = vars.maps[vars.mapnum+1]
end

local function exitlinecheck()
	for line in lines.iterate do
		if line.special == 2 then
			line.frontsector.floorheight = getnextmap()*FRACUNIT
		end
	end
end

addHook("ThinkFrame",forcemapifwrong)

addHook("PlayerThink",function(p)
	if vars.isenabled == 0 or tempdisable or gamemap == titlemap then return end
	if p.didexit != vars.maps[vars.mapnum+1] then p.didexit = nil end
	if (p.exiting > 0 or p.pflags & PF_FINISHED != 0) and not p.didexit then 
		preparemap(p)
	end
end)

addHook("MapChange",function(mapnum)
	if vars.isenabled == 0 or mapnum == vars.maps[vars.mapnum] or gamemap == titlemap then return end
	tempdisable = true
end)

addHook("MapLoad",function(mapnum)
	if vars.isenabled == 0 or gamemap == titlemap then return end
	if not justchanged then
		if mapnum == vars.maps[vars.mapnum] then return end
		vars.mapnum = $1+1
	end
	justchanged = false
	tempdisable = false
	exitlinecheck()
	if mapnum != vars.maps[vars.mapnum] then
		if vars.mapnum > #vars.maps then
			if vars.autorandom then urmain.cmds.mr_randomize.run() end
			vars.mapnum = 1
		end
		justchanged = true
		G_ExitLevel(vars.maps[vars.mapnum],2)
	else
		G_SetCustomExitVars(vars.maps[vars.mapnum+1],0)
	end
end)
