--Object definitions for Object Randomizer v2 and up
local objdefs = {}

rawset(_G,"_urandomobjdefs",objdefs)
//objdefs.limited - lookup table for Limited object type swap mode
//objdefs.smart {enemies,pickups,scenery,rest} - lookup tables for smart type swap mode
//objdefs.full - full lookup table
//objdefs.smartlist {enemies,pickups,scenery,rest} - object lists for smart type swap mode
//objdefs.fulllist - full list of all allowed objects
//objdefs.limitedlist - list for limited object type swap mode

objdefs.limited = {
[MT_BLUECRAWLA]=1,
[MT_REDCRAWLA]=1,
[MT_GFZFISH]=1,
[MT_GOLDBUZZ]=1,
[MT_REDBUZZ]=1,
[MT_JETTBOMBER]=1,
[MT_JETTGUNNER]=1,
[MT_CRAWLACOMMANDER]=1,
[MT_DETON]=1,
[MT_SKIM]=1,
[MT_POPUPTURRET]=1,
[MT_SPINCUSHION]=1,
[MT_CRUSHSTACEAN]=1,
[MT_BANPYURA]=1,
[MT_JETJAW]=1,
[MT_SNAILER]=1,
[MT_VULTURE]=1,
[MT_ROBOHOOD]=1,
[MT_FACESTABBER]=1,
[MT_EGGGUARD]=1,
[MT_GSNAPPER]=1,
[MT_MINUS]=1,
[MT_SPRINGSHELL]=1,
[MT_YELLOWSHELL]=1,
[MT_UNIDUS]=1,
[MT_CANARIVORE]=1,
[MT_PYREFLY]=1,
[MT_DRAGONBOMBER]=1,
[MT_BIGMINE]=1,
[MT_BLASTEXECUTOR]=1,
[MT_RING_BOX]=1,
[MT_PITY_BOX]=1,
[MT_ATTRACT_BOX]=1,
[MT_FORCE_BOX]=1,
[MT_ARMAGEDDON_BOX]=1,
[MT_WHIRLWIND_BOX]=1,
[MT_ELEMENTAL_BOX]=1,
[MT_SNEAKERS_BOX]=1,
[MT_INVULN_BOX]=1,
[MT_1UP_BOX]=1,
[MT_EGGMAN_BOX]=1,
[MT_MIXUP_BOX]=1,
[MT_GRAVITY_BOX]=1,
[MT_RECYCLER_BOX]=1,
[MT_SCORE1K_BOX]=1,
[MT_SCORE10K_BOX]=1,
[MT_FLAMEAURA_BOX]=1,
[MT_BUBBLEWRAP_BOX]=1,
[MT_THUNDERCOIN_BOX]=1,
[MT_PITY_GOLDBOX]=1,
[MT_ATTRACT_GOLDBOX]=1,
[MT_FORCE_GOLDBOX]=1,
[MT_ARMAGEDDON_GOLDBOX]=1,
[MT_WHIRLWIND_GOLDBOX]=1,
[MT_ELEMENTAL_GOLDBOX]=1,
[MT_SNEAKERS_GOLDBOX]=1,
[MT_INVULN_GOLDBOX]=1,
[MT_EGGMAN_GOLDBOX]=1,
[MT_GRAVITY_GOLDBOX]=1,
[MT_FLAMEAURA_GOLDBOX]=1,
[MT_BUBBLEWRAP_GOLDBOX]=1,
[MT_THUNDERCOIN_GOLDBOX]=1,
[MT_RING_REDBOX]=1,
[MT_RING_BLUEBOX]=1,
[MT_TNTBARREL]=1,
[MT_TARGET]=1,
[MT_ROSY]=1,
[MT_GOOMBA]=1,
[MT_BLUEGOOMBA]=1,
[MT_SHELL]=1,
[MT_PIAN]=1,
[MT_SHLEEP]=1,
[MT_PENGUINATOR]=1,
[MT_POPHAT]=1,
[MT_BUMBLEBORE]=1,
[MT_BUGGLE]=1,
[MT_CACOLANTERN]=1,
[MT_SPINBOBERT]=1,
[MT_HANGSTER]=1
}

objdefs.smart = {
enemies = {
[MT_BLUECRAWLA]=1,
[MT_REDCRAWLA]=1,
[MT_GFZFISH]=1,
[MT_GOLDBUZZ]=1,
[MT_REDBUZZ]=1,
[MT_JETTBOMBER]=1,
[MT_JETTGUNNER]=1,
[MT_CRAWLACOMMANDER]=1,
[MT_DETON]=1,
[MT_SKIM]=1,
[MT_POPUPTURRET]=1,
[MT_SPINCUSHION]=1,
[MT_CRUSHSTACEAN]=1,
[MT_BANPYURA]=1,
[MT_JETJAW]=1,
[MT_SNAILER]=1,
[MT_VULTURE]=1,
[MT_ROBOHOOD]=1,
[MT_FACESTABBER]=1,
[MT_EGGGUARD]=1,
[MT_GSNAPPER]=1,
[MT_MINUS]=1,
[MT_SPRINGSHELL]=1,
[MT_YELLOWSHELL]=1,
[MT_UNIDUS]=1,
[MT_CANARIVORE]=1,
[MT_PYREFLY]=1,
[MT_DRAGONBOMBER]=1,
[MT_BIGMINE]=1,
[MT_ROSY]=1,
[MT_GOOMBA]=1,
[MT_BLUEGOOMBA]=1,
[MT_PIAN]=1,
[MT_SHLEEP]=1,
[MT_PENGUINATOR]=1,
[MT_POPHAT]=1,
[MT_HIVEELEMENTAL]=1,
[MT_BUMBLEBORE]=1,
[MT_BUGGLE]=1,
[MT_CACOLANTERN]=1,
[MT_SPINBOBERT]=1,
[MT_HANGSTER]=1,
},
pickups = {
[MT_RING]=1,
[MT_BLUESPHERE]=1,
[MT_BOMBSPHERE]=1,
[MT_REDTEAMRING]=1,
[MT_BLUETEAMRING]=1,
[MT_TOKEN]=1,
[MT_REDFLAG]=1,
[MT_BLUEFLAG]=1,
[MT_EMBLEM]=1,
[MT_EMERALD1]=1,
[MT_EMERALD2]=1,
[MT_EMERALD3]=1,
[MT_EMERALD4]=1,
[MT_EMERALD5]=1,
[MT_EMERALD6]=1,
[MT_EMERALD7]=1,
[MT_RING_BOX]=1,
[MT_PITY_BOX]=1,
[MT_ATTRACT_BOX]=1,
[MT_FORCE_BOX]=1,
[MT_ARMAGEDDON_BOX]=1,
[MT_WHIRLWIND_BOX]=1,
[MT_ELEMENTAL_BOX]=1,
[MT_SNEAKERS_BOX]=1,
[MT_INVULN_BOX]=1,
[MT_1UP_BOX]=1,
[MT_EGGMAN_BOX]=1,
[MT_MIXUP_BOX]=1,
[MT_GRAVITY_BOX]=1,
[MT_RECYCLER_BOX]=1,
[MT_SCORE1K_BOX]=1,
[MT_SCORE10K_BOX]=1,
[MT_FLAMEAURA_BOX]=1,
[MT_BUBBLEWRAP_BOX]=1,
[MT_THUNDERCOIN_BOX]=1,
[MT_PITY_GOLDBOX]=1,
[MT_ATTRACT_GOLDBOX]=1,
[MT_FORCE_GOLDBOX]=1,
[MT_ARMAGEDDON_GOLDBOX]=1,
[MT_WHIRLWIND_GOLDBOX]=1,
[MT_ELEMENTAL_GOLDBOX]=1,
[MT_SNEAKERS_GOLDBOX]=1,
[MT_INVULN_GOLDBOX]=1,
[MT_EGGMAN_GOLDBOX]=1,
[MT_GRAVITY_GOLDBOX]=1,
[MT_FLAMEAURA_GOLDBOX]=1,
[MT_BUBBLEWRAP_GOLDBOX]=1,
[MT_THUNDERCOIN_GOLDBOX]=1,
[MT_RING_REDBOX]=1,
[MT_RING_BLUEBOX]=1,
[MT_BOUNCERING]=1,
[MT_RAILRING]=1,
[MT_INFINITYRING]=1,
[MT_AUTOMATICRING]=1,
[MT_EXPLOSIONRING]=1,
[MT_SCATTERRING]=1,
[MT_GRENADERING]=1,
[MT_BOUNCEPICKUP]=1,
[MT_RAILPICKUP]=1,
[MT_AUTOPICKUP]=1,
[MT_EXPLODEPICKUP]=1,
[MT_SCATTERPICKUP]=1,
[MT_GRENADEPICKUP]=1,
[MT_COIN]=1,
},
scenery = {
[MT_SIGN]=1,
[MT_SPIKE]=1,
[MT_WALLSPIKE]=1,
[MT_GFZFLOWER1]=1,
[MT_GFZFLOWER2]=1,
[MT_GFZFLOWER3]=1,
[MT_BLUEBERRYBUSH]=1,
[MT_BERRYBUSH]=1,
[MT_BUSH]=1,
[MT_GFZTREE]=1,
[MT_GFZBERRYTREE]=1,
[MT_GFZCHERRYTREE]=1,
[MT_CHECKERTREE]=1,
[MT_CHECKERSUNSETTREE]=1,
[MT_FHZTREE]=1,
[MT_FHZPINKTREE]=1,
[MT_POLYGONTREE]=1,
[MT_BUSHTREE]=1,
[MT_BUSHREDTREE]=1,
[MT_SPRINGTREE]=1,
[MT_THZFLOWER1]=1,
[MT_THZFLOWER2]=1,
[MT_THZFLOWER3]=1,
[MT_THZTREE]=1,
[MT_SEAWEED]=1,
[MT_CORAL1]=1,
[MT_CORAL2]=1,
[MT_CORAL3]=1,
[MT_CORAL4]=1,
[MT_CORAL5]=1,
[MT_BLUECRYSTAL]=1,
[MT_KELP]=1,
[MT_DSZSTALAGMITE]=1,
[MT_DSZ2STALAGMITE]=1,
[MT_LIGHTBEAM]=1,
[MT_CHAIN]=1,
[MT_EGGSTATUE]=1,
[MT_SMALLFIREBAR]=1,
[MT_BIGFIREBAR]=1,
[MT_CEZFLOWER]=1,
[MT_CEZPOLE1]=1,
[MT_CEZPOLE2]=1,
[MT_PINETREE]=1,
[MT_CEZBUSH1]=1,
[MT_CEZBUSH2]=1,
[MT_CANDLE]=1,
[MT_BRAMBLES]=1,
[MT_CACTI1]=1,
[MT_CACTI2]=1,
[MT_CACTI3]=1,
[MT_CACTI4]=1,
[MT_CACTI5]=1,
[MT_CACTI6]=1,
[MT_CACTI7]=1,
[MT_CACTI8]=1,
[MT_CACTI9]=1,
[MT_CACTI10]=1,
[MT_CACTI11]=1,
[MT_ARIDSIGN_CAUTION]=1,
[MT_ARIDSIGN_CACTI]=1,
[MT_ARIDSIGN_SHARPTURN]=1,
[MT_OILLAMP]=1,
[MT_FLAMEJET]=1,
[MT_VERTICALFLAMEJET]=1,
[MT_BIGFERN]=1,
[MT_JUNGLEPALM]=1,
[MT_TORCHFLOWER]=1,
[MT_WALLVINE_LONG]=1,
[MT_WALLVINE_SHORT]=1,
[MT_STALAGMITE0]=1,
[MT_STALAGMITE1]=1,
[MT_STALAGMITE2]=1,
[MT_STALAGMITE3]=1,
[MT_STALAGMITE4]=1,
[MT_STALAGMITE5]=1,
[MT_STALAGMITE6]=1,
[MT_STALAGMITE7]=1,
[MT_STALAGMITE8]=1,
[MT_STALAGMITE9]=1,
[MT_XMASPOLE]=1,
[MT_CANDYCANE]=1,
[MT_HANGSTAR]=1,
[MT_MISTLETOE]=1,
[MT_XMASBLUEBERRYBUSH]=1,
[MT_XMASBERRYBUSH]=1,
[MT_XMASBUSH]=1,
[MT_FHZICE1]=1,
[MT_FHZICE2]=1,
[MT_JACKO1]=1,
[MT_JACKO2]=1,
[MT_JACKO3]=1,
[MT_HHZTREE_TOP]=1,
[MT_HHZSHROOM]=1,
[MT_HHZGRASS]=1,
[MT_HHZTENTACLE1]=1,
[MT_HHZTENTACLE2]=1,
[MT_HHZSTALAGMITE_TALL]=1,
[MT_HHZSTALAGMITE_SHORT]=1,
[MT_BSZTALLFLOWER_RED]=1,
[MT_BSZTALLFLOWER_PURPLE]=1,
[MT_BSZTALLFLOWER_BLUE]=1,
[MT_BSZTALLFLOWER_CYAN]=1,
[MT_BSZTALLFLOWER_YELLOW]=1,
[MT_BSZTALLFLOWER_ORANGE]=1,
[MT_BSZFLOWER_RED]=1,
[MT_BSZFLOWER_PURPLE]=1,
[MT_BSZFLOWER_BLUE]=1,
[MT_BSZFLOWER_CYAN]=1,
[MT_BSZFLOWER_YELLOW]=1,
[MT_BSZFLOWER_ORANGE]=1,
[MT_BSZSHORTFLOWER_RED]=1,
[MT_BSZSHORTFLOWER_PURPLE]=1,
[MT_BSZSHORTFLOWER_BLUE]=1,
[MT_BSZSHORTFLOWER_CYAN]=1,
[MT_BSZSHORTFLOWER_YELLOW]=1,
[MT_BSZSHORTFLOWER_ORANGE]=1,
[MT_BSZTULIP_RED]=1,
[MT_BSZTULIP_PURPLE]=1,
[MT_BSZTULIP_BLUE]=1,
[MT_BSZTULIP_CYAN]=1,
[MT_BSZTULIP_YELLOW]=1,
[MT_BSZTULIP_ORANGE]=1,
[MT_BSZCLUSTER_RED]=1,
[MT_BSZCLUSTER_PURPLE]=1,
[MT_BSZCLUSTER_BLUE]=1,
[MT_BSZCLUSTER_CYAN]=1,
[MT_BSZCLUSTER_YELLOW]=1,
[MT_BSZCLUSTER_ORANGE]=1,
[MT_BSZBUSH_RED]=1,
[MT_BSZBUSH_PURPLE]=1,
[MT_BSZBUSH_BLUE]=1,
[MT_BSZBUSH_CYAN]=1,
[MT_BSZBUSH_YELLOW]=1,
[MT_BSZBUSH_ORANGE]=1,
[MT_BSZVINE_RED]=1,
[MT_BSZVINE_PURPLE]=1,
[MT_BSZVINE_BLUE]=1,
[MT_BSZVINE_CYAN]=1,
[MT_BSZVINE_YELLOW]=1,
[MT_BSZVINE_ORANGE]=1,
[MT_BSZSHRUB]=1,
[MT_BSZCLOVER]=1,
[MT_BIG_PALMTREE_TOP]=1,
[MT_PALMTREE_TOP]=1,
[MT_DBALL]=1,
[MT_EGGSTATUE2]=1,
[MT_MARIOBUSH1]=1,
[MT_MARIOBUSH2]=1,
[MT_TOAD]=1,
[MT_NIGHTSBUMPER]=1,
},
rest = {
[MT_TURRET]=1,
[MT_EGGROBO1]=1,
[MT_EMERHUNT]=1,
[MT_EMERALDSPAWN]=1,
[MT_SPIKEBALL]=1,
[MT_CANNONBALLDECOR]=1,
[MT_GARGOYLE]=1,
[MT_BIGGARGOYLE]=1,
[MT_ANIMALGAETOP]=1,
[MT_FLAME]=1,
[MT_SMALLMACE]=1,
[MT_BIGMACE]=1,
[MT_CANDLEPRICKET]=1,
[MT_FLAMEHOLDER]=1,
[MT_FIRETORCH]=1,
[MT_WAVINGFLAG1]=1,
[MT_WAVINGFLAG2]=1,
[MT_CRAWLASTATUE]=1,
[MT_FACESTABBERSTATUE]=1,
[MT_SUSPICIOUSFACESTABBERSTATUE]=1,
[MT_BIGTUMBLEWEED]=1,
[MT_LITTLETUMBLEWEED]=1,
[MT_TNTBARREL]=1,
[MT_PROXIMITYTNT]=1,
[MT_FJSPINAXISA]=1,
[MT_FJSPINAXISB]=1,
[MT_LAVAFALL]=1,
[MT_GLAREGOYLE]=1,
[MT_GLAREGOYLEUP]=1,
[MT_GLAREGOYLEDOWN]=1,
[MT_GLAREGOYLELONG]=1,
[MT_TARGET]=1,
[MT_GREENFLAME]=1,
[MT_BLUEGARGOYLE]=1,
[MT_SNOWMAN]=1,
[MT_SNOWMANHAT]=1,
[MT_LAMPPOST1]=1,
[MT_LAMPPOST2]=1,
[MT_FIREFLOWER]=1,
[MT_SHELL]=1,
[MT_PUMA]=1,
[MT_KOOPA]=1,
[MT_AXE]=1,
[MT_NIGHTSDRONE]=1,
[MT_NIGHTSSUPERLOOP]=1,
[MT_NIGHTSDRILLREFILL]=1,
[MT_NIGHTSHELPER]=1,
[MT_NIGHTSEXTRATIME]=1,
[MT_SMASHINGSPIKEBALL]=1,
}
}

objdefs.full = {
[MT_BLUECRAWLA]=1,
[MT_REDCRAWLA]=1,
[MT_GFZFISH]=1,
[MT_GOLDBUZZ]=1,
[MT_REDBUZZ]=1,
[MT_JETTBOMBER]=1,
[MT_JETTGUNNER]=1,
[MT_CRAWLACOMMANDER]=1,
[MT_DETON]=1,
[MT_SKIM]=1,
[MT_TURRET]=1,
[MT_POPUPTURRET]=1,
[MT_SPINCUSHION]=1,
[MT_CRUSHSTACEAN]=1,
[MT_BANPYURA]=1,
[MT_JETJAW]=1,
[MT_SNAILER]=1,
[MT_VULTURE]=1,
[MT_ROBOHOOD]=1,
[MT_FACESTABBER]=1,
[MT_EGGGUARD]=1,
[MT_GSNAPPER]=1,
[MT_MINUS]=1,
[MT_SPRINGSHELL]=1,
[MT_YELLOWSHELL]=1,
[MT_UNIDUS]=1,
[MT_CANARIVORE]=1,
[MT_PYREFLY]=1,
[MT_DRAGONBOMBER]=1,
[MT_EGGROBO1]=1,
[MT_RING]=1,
[MT_BLUESPHERE]=1,
[MT_BOMBSPHERE]=1,
[MT_REDTEAMRING]=1,
[MT_BLUETEAMRING]=1,
[MT_TOKEN]=1,
[MT_REDFLAG]=1,
[MT_BLUEFLAG]=1,
[MT_EMBLEM]=1,
[MT_EMERALD1]=1,
[MT_EMERALD2]=1,
[MT_EMERALD3]=1,
[MT_EMERALD4]=1,
[MT_EMERALD5]=1,
[MT_EMERALD6]=1,
[MT_EMERALD7]=1,
[MT_EMERHUNT]=1,
[MT_EMERALDSPAWN]=1,
[MT_SIGN]=1,
[MT_SPIKEBALL]=1,
[MT_SPIKE]=1,
[MT_WALLSPIKE]=1,
[MT_BIGMINE]=1,
[MT_RING_BOX]=1,
[MT_PITY_BOX]=1,
[MT_ATTRACT_BOX]=1,
[MT_FORCE_BOX]=1,
[MT_ARMAGEDDON_BOX]=1,
[MT_WHIRLWIND_BOX]=1,
[MT_ELEMENTAL_BOX]=1,
[MT_SNEAKERS_BOX]=1,
[MT_INVULN_BOX]=1,
[MT_1UP_BOX]=1,
[MT_EGGMAN_BOX]=1,
[MT_MIXUP_BOX]=1,
[MT_GRAVITY_BOX]=1,
[MT_RECYCLER_BOX]=1,
[MT_SCORE1K_BOX]=1,
[MT_SCORE10K_BOX]=1,
[MT_FLAMEAURA_BOX]=1,
[MT_BUBBLEWRAP_BOX]=1,
[MT_THUNDERCOIN_BOX]=1,
[MT_PITY_GOLDBOX]=1,
[MT_ATTRACT_GOLDBOX]=1,
[MT_FORCE_GOLDBOX]=1,
[MT_ARMAGEDDON_GOLDBOX]=1,
[MT_WHIRLWIND_GOLDBOX]=1,
[MT_ELEMENTAL_GOLDBOX]=1,
[MT_SNEAKERS_GOLDBOX]=1,
[MT_INVULN_GOLDBOX]=1,
[MT_EGGMAN_GOLDBOX]=1,
[MT_GRAVITY_GOLDBOX]=1,
[MT_FLAMEAURA_GOLDBOX]=1,
[MT_BUBBLEWRAP_GOLDBOX]=1,
[MT_THUNDERCOIN_GOLDBOX]=1,
[MT_RING_REDBOX]=1,
[MT_RING_BLUEBOX]=1,
[MT_CANNONBALLDECOR]=1,
[MT_GFZFLOWER1]=1,
[MT_GFZFLOWER2]=1,
[MT_GFZFLOWER3]=1,
[MT_BLUEBERRYBUSH]=1,
[MT_BERRYBUSH]=1,
[MT_BUSH]=1,
[MT_GFZTREE]=1,
[MT_GFZBERRYTREE]=1,
[MT_GFZCHERRYTREE]=1,
[MT_CHECKERTREE]=1,
[MT_CHECKERSUNSETTREE]=1,
[MT_FHZTREE]=1,
[MT_FHZPINKTREE]=1,
[MT_POLYGONTREE]=1,
[MT_BUSHTREE]=1,
[MT_BUSHREDTREE]=1,
[MT_SPRINGTREE]=1,
[MT_THZFLOWER1]=1,
[MT_THZFLOWER2]=1,
[MT_THZFLOWER3]=1,
[MT_THZTREE]=1,
[MT_GARGOYLE]=1,
[MT_BIGGARGOYLE]=1,
[MT_SEAWEED]=1,
[MT_CORAL1]=1,
[MT_CORAL2]=1,
[MT_CORAL3]=1,
[MT_CORAL4]=1,
[MT_CORAL5]=1,
[MT_BLUECRYSTAL]=1,
[MT_KELP]=1,
[MT_ANIMALGAETOP]=1,
[MT_DSZSTALAGMITE]=1,
[MT_DSZ2STALAGMITE]=1,
[MT_LIGHTBEAM]=1,
[MT_CHAIN]=1,
[MT_FLAME]=1,
[MT_EGGSTATUE]=1,
[MT_SMALLMACE]=1,
[MT_BIGMACE]=1,
[MT_SMALLFIREBAR]=1,
[MT_BIGFIREBAR]=1,
[MT_CEZFLOWER]=1,
[MT_CEZPOLE1]=1,
[MT_CEZPOLE2]=1,
[MT_PINETREE]=1,
[MT_CEZBUSH1]=1,
[MT_CEZBUSH2]=1,
[MT_CANDLE]=1,
[MT_CANDLEPRICKET]=1,
[MT_FLAMEHOLDER]=1,
[MT_FIRETORCH]=1,
[MT_WAVINGFLAG1]=1,
[MT_WAVINGFLAG2]=1,
[MT_CRAWLASTATUE]=1,
[MT_FACESTABBERSTATUE]=1,
[MT_SUSPICIOUSFACESTABBERSTATUE]=1,
[MT_BRAMBLES]=1,
[MT_BIGTUMBLEWEED]=1,
[MT_LITTLETUMBLEWEED]=1,
[MT_CACTI1]=1,
[MT_CACTI2]=1,
[MT_CACTI3]=1,
[MT_CACTI4]=1,
[MT_CACTI5]=1,
[MT_CACTI6]=1,
[MT_CACTI7]=1,
[MT_CACTI8]=1,
[MT_CACTI9]=1,
[MT_CACTI10]=1,
[MT_CACTI11]=1,
[MT_ARIDSIGN_CAUTION]=1,
[MT_ARIDSIGN_CACTI]=1,
[MT_ARIDSIGN_SHARPTURN]=1,
[MT_OILLAMP]=1,
[MT_TNTBARREL]=1,
[MT_PROXIMITYTNT]=1,
[MT_FLAMEJET]=1,
[MT_VERTICALFLAMEJET]=1,
[MT_FJSPINAXISA]=1,
[MT_FJSPINAXISB]=1,
[MT_LAVAFALL]=1,
[MT_ROLLOUTROCK]=1,
[MT_BIGFERN]=1,
[MT_JUNGLEPALM]=1,
[MT_TORCHFLOWER]=1,
[MT_WALLVINE_LONG]=1,
[MT_WALLVINE_SHORT]=1,
[MT_GLAREGOYLE]=1,
[MT_GLAREGOYLEUP]=1,
[MT_GLAREGOYLEDOWN]=1,
[MT_GLAREGOYLELONG]=1,
[MT_TARGET]=1,
[MT_GREENFLAME]=1,
[MT_BLUEGARGOYLE]=1,
[MT_STALAGMITE0]=1,
[MT_STALAGMITE1]=1,
[MT_STALAGMITE2]=1,
[MT_STALAGMITE3]=1,
[MT_STALAGMITE4]=1,
[MT_STALAGMITE5]=1,
[MT_STALAGMITE6]=1,
[MT_STALAGMITE7]=1,
[MT_STALAGMITE8]=1,
[MT_STALAGMITE9]=1,
[MT_XMASPOLE]=1,
[MT_CANDYCANE]=1,
[MT_SNOWMAN]=1,
[MT_SNOWMANHAT]=1,
[MT_LAMPPOST1]=1,
[MT_LAMPPOST2]=1,
[MT_HANGSTAR]=1,
[MT_MISTLETOE]=1,
[MT_XMASBLUEBERRYBUSH]=1,
[MT_XMASBERRYBUSH]=1,
[MT_XMASBUSH]=1,
[MT_FHZICE1]=1,
[MT_FHZICE2]=1,
[MT_ROSY]=1,
[MT_JACKO1]=1,
[MT_JACKO2]=1,
[MT_JACKO3]=1,
[MT_HHZTREE_TOP]=1,
[MT_HHZSHROOM]=1,
[MT_HHZGRASS]=1,
[MT_HHZTENTACLE1]=1,
[MT_HHZTENTACLE2]=1,
[MT_HHZSTALAGMITE_TALL]=1,
[MT_HHZSTALAGMITE_SHORT]=1,
[MT_BSZTALLFLOWER_RED]=1,
[MT_BSZTALLFLOWER_PURPLE]=1,
[MT_BSZTALLFLOWER_BLUE]=1,
[MT_BSZTALLFLOWER_CYAN]=1,
[MT_BSZTALLFLOWER_YELLOW]=1,
[MT_BSZTALLFLOWER_ORANGE]=1,
[MT_BSZFLOWER_RED]=1,
[MT_BSZFLOWER_PURPLE]=1,
[MT_BSZFLOWER_BLUE]=1,
[MT_BSZFLOWER_CYAN]=1,
[MT_BSZFLOWER_YELLOW]=1,
[MT_BSZFLOWER_ORANGE]=1,
[MT_BSZSHORTFLOWER_RED]=1,
[MT_BSZSHORTFLOWER_PURPLE]=1,
[MT_BSZSHORTFLOWER_BLUE]=1,
[MT_BSZSHORTFLOWER_CYAN]=1,
[MT_BSZSHORTFLOWER_YELLOW]=1,
[MT_BSZSHORTFLOWER_ORANGE]=1,
[MT_BSZTULIP_RED]=1,
[MT_BSZTULIP_PURPLE]=1,
[MT_BSZTULIP_BLUE]=1,
[MT_BSZTULIP_CYAN]=1,
[MT_BSZTULIP_YELLOW]=1,
[MT_BSZTULIP_ORANGE]=1,
[MT_BSZCLUSTER_RED]=1,
[MT_BSZCLUSTER_PURPLE]=1,
[MT_BSZCLUSTER_BLUE]=1,
[MT_BSZCLUSTER_CYAN]=1,
[MT_BSZCLUSTER_YELLOW]=1,
[MT_BSZCLUSTER_ORANGE]=1,
[MT_BSZBUSH_RED]=1,
[MT_BSZBUSH_PURPLE]=1,
[MT_BSZBUSH_BLUE]=1,
[MT_BSZBUSH_CYAN]=1,
[MT_BSZBUSH_YELLOW]=1,
[MT_BSZBUSH_ORANGE]=1,
[MT_BSZVINE_RED]=1,
[MT_BSZVINE_PURPLE]=1,
[MT_BSZVINE_BLUE]=1,
[MT_BSZVINE_CYAN]=1,
[MT_BSZVINE_YELLOW]=1,
[MT_BSZVINE_ORANGE]=1,
[MT_BSZSHRUB]=1,
[MT_BSZCLOVER]=1,
[MT_BIG_PALMTREE_TOP]=1,
[MT_PALMTREE_TOP]=1,
[MT_DBALL]=1,
[MT_EGGSTATUE2]=1,
[MT_BOUNCERING]=1,
[MT_RAILRING]=1,
[MT_INFINITYRING]=1,
[MT_AUTOMATICRING]=1,
[MT_EXPLOSIONRING]=1,
[MT_SCATTERRING]=1,
[MT_GRENADERING]=1,
[MT_BOUNCEPICKUP]=1,
[MT_RAILPICKUP]=1,
[MT_AUTOPICKUP]=1,
[MT_EXPLODEPICKUP]=1,
[MT_SCATTERPICKUP]=1,
[MT_GRENADEPICKUP]=1,
[MT_COIN]=1,
[MT_GOOMBA]=1,
[MT_BLUEGOOMBA]=1,
[MT_FIREFLOWER]=1,
[MT_SHELL]=1,
[MT_PUMA]=1,
[MT_KOOPA]=1,
[MT_AXE]=1,
[MT_MARIOBUSH1]=1,
[MT_MARIOBUSH2]=1,
[MT_TOAD]=1,
[MT_NIGHTSBUMPER]=1,
[MT_NIGHTSSUPERLOOP]=1,
[MT_NIGHTSDRILLREFILL]=1,
[MT_NIGHTSHELPER]=1,
[MT_NIGHTSEXTRATIME]=1,
[MT_PIAN]=1,
[MT_SHLEEP]=1,
[MT_PENGUINATOR]=1,
[MT_POPHAT]=1,
[MT_BUMBLEBORE]=1,
[MT_BUGGLE]=1,
[MT_SMASHINGSPIKEBALL]=1,
[MT_CACOLANTERN]=1,
[MT_SPINBOBERT]=1,
[MT_HANGSTER]=1,
}

objdefs.fulllist = {
MT_BLUECRAWLA,
MT_REDCRAWLA,
MT_GFZFISH,
MT_GOLDBUZZ,
MT_REDBUZZ,
MT_JETTBOMBER,
MT_JETTGUNNER,
MT_CRAWLACOMMANDER,
MT_DETON,
MT_SKIM,
MT_TURRET,
MT_POPUPTURRET,
MT_SPINCUSHION,
MT_CRUSHSTACEAN,
MT_BANPYURA,
MT_JETJAW,
MT_SNAILER,
MT_VULTURE,
MT_ROBOHOOD,
MT_FACESTABBER,
MT_EGGGUARD,
MT_GSNAPPER,
MT_MINUS,
MT_SPRINGSHELL,
MT_YELLOWSHELL,
MT_UNIDUS,
MT_CANARIVORE,
MT_PYREFLY,
MT_DRAGONBOMBER,
MT_EGGROBO1,
MT_RING,
MT_BLUESPHERE,
MT_BOMBSPHERE,
MT_REDTEAMRING,
MT_BLUETEAMRING,
MT_TOKEN,
MT_REDFLAG,
MT_BLUEFLAG,
MT_EMBLEM,
MT_EMERALD1,
MT_EMERALD2,
MT_EMERALD3,
MT_EMERALD4,
MT_EMERALD5,
MT_EMERALD6,
MT_EMERALD7,
MT_EMERHUNT,
MT_EMERALDSPAWN,
MT_SIGN,
MT_SPIKEBALL,
MT_SPIKE,
MT_WALLSPIKE,
MT_BIGMINE,
MT_RING_BOX,
MT_PITY_BOX,
MT_ATTRACT_BOX,
MT_FORCE_BOX,
MT_ARMAGEDDON_BOX,
MT_WHIRLWIND_BOX,
MT_ELEMENTAL_BOX,
MT_SNEAKERS_BOX,
MT_INVULN_BOX,
MT_1UP_BOX,
MT_EGGMAN_BOX,
MT_MIXUP_BOX,
MT_GRAVITY_BOX,
MT_RECYCLER_BOX,
MT_SCORE1K_BOX,
MT_SCORE10K_BOX,
MT_FLAMEAURA_BOX,
MT_BUBBLEWRAP_BOX,
MT_THUNDERCOIN_BOX,
MT_PITY_GOLDBOX,
MT_ATTRACT_GOLDBOX,
MT_FORCE_GOLDBOX,
MT_ARMAGEDDON_GOLDBOX,
MT_WHIRLWIND_GOLDBOX,
MT_ELEMENTAL_GOLDBOX,
MT_SNEAKERS_GOLDBOX,
MT_INVULN_GOLDBOX,
MT_EGGMAN_GOLDBOX,
MT_GRAVITY_GOLDBOX,
MT_FLAMEAURA_GOLDBOX,
MT_BUBBLEWRAP_GOLDBOX,
MT_THUNDERCOIN_GOLDBOX,
MT_RING_REDBOX,
MT_RING_BLUEBOX,
MT_CANNONBALLDECOR,
MT_GFZFLOWER1,
MT_GFZFLOWER2,
MT_GFZFLOWER3,
MT_BLUEBERRYBUSH,
MT_BERRYBUSH,
MT_BUSH,
MT_GFZTREE,
MT_GFZBERRYTREE,
MT_GFZCHERRYTREE,
MT_CHECKERTREE,
MT_CHECKERSUNSETTREE,
MT_FHZTREE,
MT_FHZPINKTREE,
MT_POLYGONTREE,
MT_BUSHTREE,
MT_BUSHREDTREE,
MT_SPRINGTREE,
MT_THZFLOWER1,
MT_THZFLOWER2,
MT_THZFLOWER3,
MT_THZTREE,
MT_GARGOYLE,
MT_BIGGARGOYLE,
MT_SEAWEED,
MT_CORAL1,
MT_CORAL2,
MT_CORAL3,
MT_CORAL4,
MT_CORAL5,
MT_BLUECRYSTAL,
MT_KELP,
MT_ANIMALGAETOP,
MT_DSZSTALAGMITE,
MT_DSZ2STALAGMITE,
MT_LIGHTBEAM,
MT_CHAIN,
MT_FLAME,
MT_EGGSTATUE,
MT_SMALLMACE,
MT_BIGMACE,
MT_SMALLFIREBAR,
MT_BIGFIREBAR,
MT_CEZFLOWER,
MT_CEZPOLE1,
MT_CEZPOLE2,
MT_PINETREE,
MT_CEZBUSH1,
MT_CEZBUSH2,
MT_CANDLE,
MT_CANDLEPRICKET,
MT_FLAMEHOLDER,
MT_FIRETORCH,
MT_WAVINGFLAG1,
MT_WAVINGFLAG2,
MT_CRAWLASTATUE,
MT_FACESTABBERSTATUE,
MT_SUSPICIOUSFACESTABBERSTATUE,
MT_BRAMBLES,
MT_BIGTUMBLEWEED,
MT_LITTLETUMBLEWEED,
MT_CACTI1,
MT_CACTI2,
MT_CACTI3,
MT_CACTI4,
MT_CACTI5,
MT_CACTI6,
MT_CACTI7,
MT_CACTI8,
MT_CACTI9,
MT_CACTI10,
MT_CACTI11,
MT_ARIDSIGN_CAUTION,
MT_ARIDSIGN_CACTI,
MT_ARIDSIGN_SHARPTURN,
MT_OILLAMP,
MT_TNTBARREL,
MT_PROXIMITYTNT,
MT_FLAMEJET,
MT_VERTICALFLAMEJET,
MT_FJSPINAXISA,
MT_FJSPINAXISB,
MT_LAVAFALL,
MT_ROLLOUTROCK,
MT_BIGFERN,
MT_JUNGLEPALM,
MT_TORCHFLOWER,
MT_WALLVINE_LONG,
MT_WALLVINE_SHORT,
MT_GLAREGOYLE,
MT_GLAREGOYLEUP,
MT_GLAREGOYLEDOWN,
MT_GLAREGOYLELONG,
MT_TARGET,
MT_GREENFLAME,
MT_BLUEGARGOYLE,
MT_STALAGMITE0,
MT_STALAGMITE1,
MT_STALAGMITE2,
MT_STALAGMITE3,
MT_STALAGMITE4,
MT_STALAGMITE5,
MT_STALAGMITE6,
MT_STALAGMITE7,
MT_STALAGMITE8,
MT_STALAGMITE9,
MT_XMASPOLE,
MT_CANDYCANE,
MT_SNOWMAN,
MT_SNOWMANHAT,
MT_LAMPPOST1,
MT_LAMPPOST2,
MT_HANGSTAR,
MT_MISTLETOE,
MT_XMASBLUEBERRYBUSH,
MT_XMASBERRYBUSH,
MT_XMASBUSH,
MT_FHZICE1,
MT_FHZICE2,
MT_ROSY,
MT_JACKO1,
MT_JACKO2,
MT_JACKO3,
MT_HHZTREE_TOP,
MT_HHZSHROOM,
MT_HHZGRASS,
MT_HHZTENTACLE1,
MT_HHZTENTACLE2,
MT_HHZSTALAGMITE_TALL,
MT_HHZSTALAGMITE_SHORT,
MT_BSZTALLFLOWER_RED,
MT_BSZTALLFLOWER_PURPLE,
MT_BSZTALLFLOWER_BLUE,
MT_BSZTALLFLOWER_CYAN,
MT_BSZTALLFLOWER_YELLOW,
MT_BSZTALLFLOWER_ORANGE,
MT_BSZFLOWER_RED,
MT_BSZFLOWER_PURPLE,
MT_BSZFLOWER_BLUE,
MT_BSZFLOWER_CYAN,
MT_BSZFLOWER_YELLOW,
MT_BSZFLOWER_ORANGE,
MT_BSZSHORTFLOWER_RED,
MT_BSZSHORTFLOWER_PURPLE,
MT_BSZSHORTFLOWER_BLUE,
MT_BSZSHORTFLOWER_CYAN,
MT_BSZSHORTFLOWER_YELLOW,
MT_BSZSHORTFLOWER_ORANGE,
MT_BSZTULIP_RED,
MT_BSZTULIP_PURPLE,
MT_BSZTULIP_BLUE,
MT_BSZTULIP_CYAN,
MT_BSZTULIP_YELLOW,
MT_BSZTULIP_ORANGE,
MT_BSZCLUSTER_RED,
MT_BSZCLUSTER_PURPLE,
MT_BSZCLUSTER_BLUE,
MT_BSZCLUSTER_CYAN,
MT_BSZCLUSTER_YELLOW,
MT_BSZCLUSTER_ORANGE,
MT_BSZBUSH_RED,
MT_BSZBUSH_PURPLE,
MT_BSZBUSH_BLUE,
MT_BSZBUSH_CYAN,
MT_BSZBUSH_YELLOW,
MT_BSZBUSH_ORANGE,
MT_BSZVINE_RED,
MT_BSZVINE_PURPLE,
MT_BSZVINE_BLUE,
MT_BSZVINE_CYAN,
MT_BSZVINE_YELLOW,
MT_BSZVINE_ORANGE,
MT_BSZSHRUB,
MT_BSZCLOVER,
MT_BIG_PALMTREE_TOP,
MT_PALMTREE_TOP,
MT_DBALL,
MT_EGGSTATUE2,
MT_BOUNCERING,
MT_RAILRING,
MT_INFINITYRING,
MT_AUTOMATICRING,
MT_EXPLOSIONRING,
MT_SCATTERRING,
MT_GRENADERING,
MT_BOUNCEPICKUP,
MT_RAILPICKUP,
MT_AUTOPICKUP,
MT_EXPLODEPICKUP,
MT_SCATTERPICKUP,
MT_GRENADEPICKUP,
MT_COIN,
MT_GOOMBA,
MT_BLUEGOOMBA,
MT_FIREFLOWER,
MT_SHELL,
MT_PUMA,
MT_KOOPA,
MT_AXE,
MT_MARIOBUSH1,
MT_MARIOBUSH2,
MT_TOAD,
MT_NIGHTSBUMPER,
MT_NIGHTSSUPERLOOP,
MT_NIGHTSDRILLREFILL,
MT_NIGHTSHELPER,
MT_NIGHTSEXTRATIME,
MT_PIAN,
MT_SHLEEP,
MT_PENGUINATOR,
MT_POPHAT,
MT_BUMBLEBORE,
MT_BUGGLE,
MT_SMASHINGSPIKEBALL,
MT_CACOLANTERN,
MT_SPINBOBERT,
MT_HANGSTER,
}

objdefs.smartlist = {
enemies = {
MT_BLUECRAWLA,
MT_REDCRAWLA,
MT_GFZFISH,
MT_GOLDBUZZ,
MT_REDBUZZ,
MT_JETTBOMBER,
MT_JETTGUNNER,
MT_CRAWLACOMMANDER,
MT_DETON,
MT_SKIM,
MT_POPUPTURRET,
MT_SPINCUSHION,
MT_CRUSHSTACEAN,
MT_BANPYURA,
MT_JETJAW,
MT_SNAILER,
MT_VULTURE,
MT_ROBOHOOD,
MT_FACESTABBER,
MT_EGGGUARD,
MT_GSNAPPER,
MT_MINUS,
MT_SPRINGSHELL,
MT_YELLOWSHELL,
MT_UNIDUS,
MT_CANARIVORE,
MT_PYREFLY,
MT_DRAGONBOMBER,
MT_BIGMINE,
MT_ROSY,
MT_GOOMBA,
MT_BLUEGOOMBA,
MT_PIAN,
MT_SHLEEP,
MT_PENGUINATOR,
MT_POPHAT,
MT_BUMBLEBORE,
MT_BUGGLE,
MT_CACOLANTERN,
MT_SPINBOBERT,
MT_HANGSTER,
},
pickups = {
MT_RING,
MT_BLUESPHERE,
MT_BOMBSPHERE,
MT_REDTEAMRING,
MT_BLUETEAMRING,
MT_TOKEN,
MT_REDFLAG,
MT_BLUEFLAG,
MT_EMBLEM,
MT_EMERALD1,
MT_EMERALD2,
MT_EMERALD3,
MT_EMERALD4,
MT_EMERALD5,
MT_EMERALD6,
MT_EMERALD7,
MT_RING_BOX,
MT_PITY_BOX,
MT_ATTRACT_BOX,
MT_FORCE_BOX,
MT_ARMAGEDDON_BOX,
MT_WHIRLWIND_BOX,
MT_ELEMENTAL_BOX,
MT_SNEAKERS_BOX,
MT_INVULN_BOX,
MT_1UP_BOX,
MT_EGGMAN_BOX,
MT_MIXUP_BOX,
MT_GRAVITY_BOX,
MT_RECYCLER_BOX,
MT_SCORE1K_BOX,
MT_SCORE10K_BOX,
MT_FLAMEAURA_BOX,
MT_BUBBLEWRAP_BOX,
MT_THUNDERCOIN_BOX,
MT_PITY_GOLDBOX,
MT_ATTRACT_GOLDBOX,
MT_FORCE_GOLDBOX,
MT_ARMAGEDDON_GOLDBOX,
MT_WHIRLWIND_GOLDBOX,
MT_ELEMENTAL_GOLDBOX,
MT_SNEAKERS_GOLDBOX,
MT_INVULN_GOLDBOX,
MT_EGGMAN_GOLDBOX,
MT_GRAVITY_GOLDBOX,
MT_FLAMEAURA_GOLDBOX,
MT_BUBBLEWRAP_GOLDBOX,
MT_THUNDERCOIN_GOLDBOX,
MT_RING_REDBOX,
MT_RING_BLUEBOX,
MT_BOUNCERING,
MT_RAILRING,
MT_INFINITYRING,
MT_AUTOMATICRING,
MT_EXPLOSIONRING,
MT_SCATTERRING,
MT_GRENADERING,
MT_BOUNCEPICKUP,
MT_RAILPICKUP,
MT_AUTOPICKUP,
MT_EXPLODEPICKUP,
MT_SCATTERPICKUP,
MT_GRENADEPICKUP,
MT_COIN,
},
scenery = {
MT_SIGN,
MT_SPIKE,
MT_WALLSPIKE,
MT_GFZFLOWER1,
MT_GFZFLOWER2,
MT_GFZFLOWER3,
MT_BLUEBERRYBUSH,
MT_BERRYBUSH,
MT_BUSH,
MT_GFZTREE,
MT_GFZBERRYTREE,
MT_GFZCHERRYTREE,
MT_CHECKERTREE,
MT_CHECKERSUNSETTREE,
MT_FHZTREE,
MT_FHZPINKTREE,
MT_POLYGONTREE,
MT_BUSHTREE,
MT_BUSHREDTREE,
MT_SPRINGTREE,
MT_THZFLOWER1,
MT_THZFLOWER2,
MT_THZFLOWER3,
MT_THZTREE,
MT_SEAWEED,
MT_CORAL1,
MT_CORAL2,
MT_CORAL3,
MT_CORAL4,
MT_CORAL5,
MT_BLUECRYSTAL,
MT_KELP,
MT_DSZSTALAGMITE,
MT_DSZ2STALAGMITE,
MT_LIGHTBEAM,
MT_CHAIN,
MT_EGGSTATUE,
MT_SMALLFIREBAR,
MT_BIGFIREBAR,
MT_CEZFLOWER,
MT_CEZPOLE1,
MT_CEZPOLE2,
MT_PINETREE,
MT_CEZBUSH1,
MT_CEZBUSH2,
MT_CANDLE,
MT_BRAMBLES,
MT_CACTI1,
MT_CACTI2,
MT_CACTI3,
MT_CACTI4,
MT_CACTI5,
MT_CACTI6,
MT_CACTI7,
MT_CACTI8,
MT_CACTI9,
MT_CACTI10,
MT_CACTI11,
MT_ARIDSIGN_CAUTION,
MT_ARIDSIGN_CACTI,
MT_ARIDSIGN_SHARPTURN,
MT_OILLAMP,
MT_FLAMEJET,
MT_VERTICALFLAMEJET,
MT_BIGFERN,
MT_JUNGLEPALM,
MT_TORCHFLOWER,
MT_WALLVINE_LONG,
MT_WALLVINE_SHORT,
MT_STALAGMITE0,
MT_STALAGMITE1,
MT_STALAGMITE2,
MT_STALAGMITE3,
MT_STALAGMITE4,
MT_STALAGMITE5,
MT_STALAGMITE6,
MT_STALAGMITE7,
MT_STALAGMITE8,
MT_STALAGMITE9,
MT_XMASPOLE,
MT_CANDYCANE,
MT_HANGSTAR,
MT_MISTLETOE,
MT_XMASBLUEBERRYBUSH,
MT_XMASBERRYBUSH,
MT_XMASBUSH,
MT_FHZICE1,
MT_FHZICE2,
MT_JACKO1,
MT_JACKO2,
MT_JACKO3,
MT_HHZTREE_TOP,
MT_HHZSHROOM,
MT_HHZGRASS,
MT_HHZTENTACLE1,
MT_HHZTENTACLE2,
MT_HHZSTALAGMITE_TALL,
MT_HHZSTALAGMITE_SHORT,
MT_BSZTALLFLOWER_RED,
MT_BSZTALLFLOWER_PURPLE,
MT_BSZTALLFLOWER_BLUE,
MT_BSZTALLFLOWER_CYAN,
MT_BSZTALLFLOWER_YELLOW,
MT_BSZTALLFLOWER_ORANGE,
MT_BSZFLOWER_RED,
MT_BSZFLOWER_PURPLE,
MT_BSZFLOWER_BLUE,
MT_BSZFLOWER_CYAN,
MT_BSZFLOWER_YELLOW,
MT_BSZFLOWER_ORANGE,
MT_BSZSHORTFLOWER_RED,
MT_BSZSHORTFLOWER_PURPLE,
MT_BSZSHORTFLOWER_BLUE,
MT_BSZSHORTFLOWER_CYAN,
MT_BSZSHORTFLOWER_YELLOW,
MT_BSZSHORTFLOWER_ORANGE,
MT_BSZTULIP_RED,
MT_BSZTULIP_PURPLE,
MT_BSZTULIP_BLUE,
MT_BSZTULIP_CYAN,
MT_BSZTULIP_YELLOW,
MT_BSZTULIP_ORANGE,
MT_BSZCLUSTER_RED,
MT_BSZCLUSTER_PURPLE,
MT_BSZCLUSTER_BLUE,
MT_BSZCLUSTER_CYAN,
MT_BSZCLUSTER_YELLOW,
MT_BSZCLUSTER_ORANGE,
MT_BSZBUSH_RED,
MT_BSZBUSH_PURPLE,
MT_BSZBUSH_BLUE,
MT_BSZBUSH_CYAN,
MT_BSZBUSH_YELLOW,
MT_BSZBUSH_ORANGE,
MT_BSZVINE_RED,
MT_BSZVINE_PURPLE,
MT_BSZVINE_BLUE,
MT_BSZVINE_CYAN,
MT_BSZVINE_YELLOW,
MT_BSZVINE_ORANGE,
MT_BSZSHRUB,
MT_BSZCLOVER,
MT_BIG_PALMTREE_TOP,
MT_PALMTREE_TOP,
MT_DBALL,
MT_EGGSTATUE2,
MT_MARIOBUSH1,
MT_MARIOBUSH2,
MT_TOAD,
MT_NIGHTSBUMPER,
},
rest = {
MT_TURRET,
MT_EGGROBO1,
MT_EMERHUNT,
MT_EMERALDSPAWN,
MT_SPIKEBALL,
MT_CANNONBALLDECOR,
MT_GARGOYLE,
MT_BIGGARGOYLE,
MT_ANIMALGAETOP,
MT_FLAME,
MT_SMALLMACE,
MT_BIGMACE,
MT_CANDLEPRICKET,
MT_FLAMEHOLDER,
MT_FIRETORCH,
MT_WAVINGFLAG1,
MT_WAVINGFLAG2,
MT_CRAWLASTATUE,
MT_FACESTABBERSTATUE,
MT_SUSPICIOUSFACESTABBERSTATUE,
MT_BIGTUMBLEWEED,
MT_LITTLETUMBLEWEED,
MT_TNTBARREL,
MT_PROXIMITYTNT,
MT_FJSPINAXISA,
MT_FJSPINAXISB,
MT_LAVAFALL,
MT_GLAREGOYLE,
MT_GLAREGOYLEUP,
MT_GLAREGOYLEDOWN,
MT_GLAREGOYLELONG,
MT_TARGET,
MT_GREENFLAME,
MT_BLUEGARGOYLE,
MT_SNOWMAN,
MT_SNOWMANHAT,
MT_LAMPPOST1,
MT_LAMPPOST2,
MT_FIREFLOWER,
MT_SHELL,
MT_PUMA,
MT_KOOPA,
MT_AXE,
MT_NIGHTSDRONE,
MT_NIGHTSSUPERLOOP,
MT_NIGHTSDRILLREFILL,
MT_NIGHTSHELPER,
MT_NIGHTSEXTRATIME,
MT_SMASHINGSPIKEBALL,
}
}

objdefs.limitedlist = {
MT_BLUECRAWLA,
MT_REDCRAWLA,
MT_GFZFISH,
MT_GOLDBUZZ,
MT_REDBUZZ,
MT_JETTBOMBER,
MT_JETTGUNNER,
MT_CRAWLACOMMANDER,
MT_DETON,
MT_SKIM,
MT_POPUPTURRET,
MT_SPINCUSHION,
MT_CRUSHSTACEAN,
MT_BANPYURA,
MT_JETJAW,
MT_SNAILER,
MT_VULTURE,
MT_ROBOHOOD,
MT_FACESTABBER,
MT_EGGGUARD,
MT_GSNAPPER,
MT_MINUS,
MT_SPRINGSHELL,
MT_YELLOWSHELL,
MT_UNIDUS,
MT_CANARIVORE,
MT_PYREFLY,
MT_DRAGONBOMBER,
MT_BIGMINE,
MT_BLASTEXECUTOR,
MT_RING_BOX,
MT_PITY_BOX,
MT_ATTRACT_BOX,
MT_FORCE_BOX,
MT_ARMAGEDDON_BOX,
MT_WHIRLWIND_BOX,
MT_ELEMENTAL_BOX,
MT_SNEAKERS_BOX,
MT_INVULN_BOX,
MT_1UP_BOX,
MT_EGGMAN_BOX,
MT_MIXUP_BOX,
MT_GRAVITY_BOX,
MT_RECYCLER_BOX,
MT_SCORE1K_BOX,
MT_SCORE10K_BOX,
MT_FLAMEAURA_BOX,
MT_BUBBLEWRAP_BOX,
MT_THUNDERCOIN_BOX,
MT_PITY_GOLDBOX,
MT_ATTRACT_GOLDBOX,
MT_FORCE_GOLDBOX,
MT_ARMAGEDDON_GOLDBOX,
MT_WHIRLWIND_GOLDBOX,
MT_ELEMENTAL_GOLDBOX,
MT_SNEAKERS_GOLDBOX,
MT_INVULN_GOLDBOX,
MT_EGGMAN_GOLDBOX,
MT_GRAVITY_GOLDBOX,
MT_FLAMEAURA_GOLDBOX,
MT_BUBBLEWRAP_GOLDBOX,
MT_THUNDERCOIN_GOLDBOX,
MT_RING_REDBOX,
MT_RING_BLUEBOX,
MT_TNTBARREL,
MT_TARGET,
MT_ROSY,
MT_GOOMBA,
MT_BLUEGOOMBA,
MT_SHELL,
MT_PIAN,
MT_SHLEEP,
MT_PENGUINATOR,
MT_POPHAT,
MT_BUMBLEBORE,
MT_BUGGLE,
MT_CACOLANTERN,
MT_SPINBOBERT,
MT_HANGSTER,
}
