--Physics Randomizer
--Made by Nightwolf

local urmain = assert(_URANDOM,"URANDOM: variables.lua isn't loaded properly!")
local vars = urmain.var.physrandom

local SMALLBITS = 4
local SMALLFRAC = FRACUNIT>>SMALLBITS //4096

local function resetphys(p)
	if not p.physrandom then return end
	p.normalspeed = skins[p.realmo.skin].normalspeed
	p.acceleration = skins[p.realmo.skin].acceleration
	p.mindash = skins[p.realmo.skin].mindash
	p.maxdash = skins[p.realmo.skin].maxdash
	p.jumpfactor = skins[p.realmo.skin].jumpfactor
	p.actionspd = skins[p.realmo.skin].actionspd
	p.physrandom = nil
	p.phystime = nil
	if not p.mo then return end
	p.mo.friction = 29*FRACUNIT/32
end

local function checkdata(p)
	if not p.physrandom or not p.mo then return end
	p.physrandom.lastskin = p.mo.skin
	if vars.speed > 0 then
		p.normalspeed = p.physrandom.normalspeed or $1
		p.acceleration = p.physrandom.acceleration or $1
	end
	if vars.spindash > 0 then
		p.mindash = p.physrandom.mindash or $1
		p.maxdash = p.physrandom.maxdash or $1
	end
	if vars.friction > 0 then
		p.mo.friction = p.physrandom.friction or $1
	end
	if vars.jumping > 0 then
		p.jumpfactor = p.physrandom.jumpfactor or $1
	end
	if vars.actionspd > 0 then
		p.actionspd = p.physrandom.actionspd or $1
	end
end

local function randomizephys(p)
	if not p.mo then return end
	local randmultip
	resetphys(p)
	p.phystime = vars.phtime * TICRATE
	p.physrandom = {}
	if vars.speed == 1 then
		randmultip = P_RandomRange(SMALLFRAC/2,SMALLFRAC*2)<<SMALLBITS //<<SMALLBITS converts SMALLFRAC back to FRACUNIT
		p.physrandom.normalspeed = FixedMul(p.normalspeed,randmultip)
		p.physrandom.acceleration = FixedMul(p.acceleration,randmultip)
	elseif vars.speed == 2 then
		if P_RandomChance(FRACUNIT/2) then randmultip = P_RandomRange(SMALLFRAC/8,SMALLFRAC)<<SMALLBITS
		else randmultip = P_RandomRange(SMALLFRAC,SMALLFRAC*8)<<SMALLBITS end
		p.physrandom.normalspeed = FixedMul(p.normalspeed,randmultip)
		if P_RandomChance(FRACUNIT/2) then randmultip = P_RandomRange(-SMALLFRAC*2,0)<<SMALLBITS
		else randmultip = P_RandomRange(0,SMALLFRAC*4)<<SMALLBITS end
		p.physrandom.acceleration = FixedMul(p.acceleration,randmultip)
	end
	if vars.spindash == 1 then
		randmultip = P_RandomRange(SMALLFRAC/2,SMALLFRAC*2)<<SMALLBITS
		p.physrandom.mindash = FixedMul(p.mindash,randmultip)
		randmultip = P_RandomRange(SMALLFRAC/2,SMALLFRAC*2)<<SMALLBITS
		p.physrandom.maxdash = FixedMul(p.maxdash,randmultip)
	elseif vars.spindash == 2 then
		if P_RandomChance(FRACUNIT/2) then randmultip = P_RandomRange(SMALLFRAC/8,SMALLFRAC)<<SMALLBITS
		else randmultip = P_RandomRange(SMALLFRAC,SMALLFRAC*8)<<SMALLBITS end
		p.physrandom.mindash = FixedMul(p.mindash,randmultip)
		if P_RandomChance(FRACUNIT/2) then randmultip = P_RandomRange(SMALLFRAC/8,SMALLFRAC)<<SMALLBITS
		else randmultip = P_RandomRange(SMALLFRAC,SMALLFRAC*8)<<SMALLBITS end
		p.physrandom.maxdash = FixedMul(p.maxdash,randmultip)
	end
	if vars.friction == 1 then
		//Default friction is 29*FRACUNIT/32 -> 58*FRACUNIT/64
		p.physrandom.friction = P_RandomRange(54*FRACUNIT/64,62*FRACUNIT/64)
	elseif vars.friction == 2 then
		p.physrandom.friction = P_RandomRange(SMALLFRAC/2,3*SMALLFRAC/2)<<SMALLBITS
	end
	if vars.jumping == 1 then
		randmultip = P_RandomRange(SMALLFRAC/2,SMALLFRAC*2)<<SMALLBITS
		p.physrandom.jumpfactor = FixedMul(p.jumpfactor,randmultip)
	elseif vars.jumping == 2 then
		if P_RandomChance(FRACUNIT/2) then randmultip = P_RandomRange(SMALLFRAC/8,SMALLFRAC)<<SMALLBITS
		else randmultip = P_RandomRange(SMALLFRAC,SMALLFRAC*8)<<SMALLBITS end
		p.physrandom.jumpfactor = FixedMul(p.jumpfactor,randmultip)
	end
	if vars.actionspd == 1 then
		randmultip = P_RandomRange(SMALLFRAC/2,SMALLFRAC*2)<<SMALLBITS
		p.physrandom.actionspd = FixedMul(p.actionspd,randmultip)
	elseif vars.actionspd == 2 then
		if P_RandomChance(FRACUNIT/2) then randmultip = P_RandomRange(-SMALLFRAC*2,0)<<SMALLBITS
		else randmultip = P_RandomRange(0,SMALLFRAC*8)<<SMALLBITS end
		p.physrandom.actionspd = FixedMul(p.actionspd,randmultip)
	end
end

addHook("PlayerThink",function(p)
	if vars.isenabled == 0 or modeattacking then resetphys(p); return end
	if not p.mo then return end
	if p.exiting > 0 then p.phystime = 0; return end
	if p.mo.health < 1 then p.phystime = 0; return end
	if mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS then return end
	if not p.phystime or not p.physrandom then randomizephys(p); checkdata(p) end
	p.phystime = $1 - 1
	if p.phystime < 1 then randomizephys(p); checkdata(p) end
	if p.physrandom.lastskin != p.mo.skin then checkdata(p) end
end)

hud.add(function(v,p,cam)
	if vars.showtimer == 0 then return end
	if vars.isenabled == 0 or modeattacking then return end
	if vars.speed == 0 and vars.spindash == 0 and vars.friction == 0 and vars.jumping == 0 and vars.actionspd == 0 then return end
	if not p.mo then return end
	if p.exiting > 0 return end
	if p.mo.health < 1 then return end
	if mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS then return end
	if not p.phystime then return end
	local timemin = G_TicsToMinutes(p.phystime,true)
	local timesec = G_TicsToSeconds(p.phystime)
	local timecsec = G_TicsToCentiseconds(p.phystime)
	local timestr
	if p.phystime < TICRATE*vars.phtime/10 then
		timestr = string.format("Physics change in:\x85 %d:%02d:%02d",timemin,timesec,timecsec)
	elseif p.phystime < TICRATE*vars.phtime/4 then 
		timestr = string.format("Physics change in:\x82 %d:%02d:%02d",timemin,timesec,timecsec)
	else
		timestr = string.format("Physics change in:\x83 %d:%02d:%02d",timemin,timesec,timecsec)
	end
	if p.phystime < 1 then timestr = "Physics change in:\x85".."0:00.00" end
	v.drawString(300,0,timestr,V_SNAPTORIGHT|V_PERPLAYER,"right")
end,"game")
